%% -*- Mode: prolog -*-
%% $Id: spieler1.pl,v 2.0 2000/06/13 12:00:36 stolzen Exp $
  
:- dynamic moved/0.

start_pos(1, -40, 0).
start_pos(2, -22, -15).
start_pos(3, -25, 0).
start_pos(4, -22, 15).
start_pos(5, -10, -25).
start_pos(6, -5, -10).
start_pos(7, -5, 10).
start_pos(8, -10, 25).
start_pos(9, -1, 12).
start_pos(9, -9, 0).
start_pos(10, -1, -17).
start_pos(11, -1, 0).

behave :-
	(play_mode(before_kick_off);
	 play_mode(half_time)),
	setup.


behave :-
	(play_mode(play_on); play_mode(my_kick_off)),
	retractall(moved),
	kick_and_run.

behave :-
	(play_mode(my_kick_in);
	    play_mode(my_offside_kick);
	    play_mode(my_corner_kick);
	    play_mode(my_free_kick)),
	kick_in.

behave.


setup :-
	moved.

setup :-
	my_number(N),
	start_pos(N,X,Y),
	move(X,Y),
	asserta(moved).

kick_and_run :-
	kick_if_possible.

kick_and_run :-
	my_conf,
	ball_position_valid,
	go_to_ball.

kick_and_run :-
	my_number(A),
	my_team_name(B),
	write('kick_and_run: player('),
	write(A), write(', '), write(B), write(').'), 
%	scan_field_with_body,
	turn(50),
	write('scan over.'), nl.

kick_and_run.


go_to_ball :-
	play_mode(my_kick_off),
	my_side(S),
	my_number(N),
	player_interceptionable(S,N),
	go_to_static_ball(0).

go_to_ball :-
	my_side(S),
	my_number(N),
	player_interceptionable(S,N),
	player_interception_point(S,N,X,Y),
	test_go_to_point_maybe(X,Y,0,99,N).

go_to_ball :-
	face_ball.

test_go_to_point_maybe(X,Y,I,J,N) :-
	N > 7,
	my_pos(X1,_),
	(X > -10; X1 < X),
	test_go_to_point(X,Y,I,J).

test_go_to_point_maybe(X,Y,I,J,N) :-
	N > 7,
	face_ball.

test_go_to_point_maybe(X,Y,I,J,N) :-
	N < 5,
	my_pos(X1,_),
	X > 10,
	X1 < X,
	face_ball.

test_go_to_point_maybe(X,Y,I,J,1) :-
	X > -30,
	my_pos(X1,_),
	X1 < X,
	face_ball.

test_go_to_point_maybe(X,Y,I,J,_) :-
	test_go_to_point(X,Y,I,J).


kick_if_possible :-
	ball_kickable,
	their_goal_marker(Goal),
	marker_angle_from_body(Goal, A),
        kick(100,A).

face_ball :-
	ball_position_valid,
	ball_angle_from_neck(A),
	turn(A).

face_ball :-
	write('face_ball: turn...'),
%	scan_field_with_body,
	turn(50),
	write('done.'), nl.

face_ball.


kick_in :-
	ball_kickable,
	kick_if_possible.

kick_in :-
	my_side(S),
	my_number(N),
	N > 1,
	player_interceptionable(S,N),
	go_to_static_ball(0).	
	
	
