/* -*- Mode: C++ -*-
   
   this file is part of the robolog libraries
   Copyright (C) Dec 27 1999 Oliver Obst
   main file for the robolog swi-prolog library
   $Id: swi-robolog.C,v 2.15 2000/08/22 14:03:41 fruit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdlib.h>                                                      
#include <stdio.h>
#include <iostream>

#if STDC_HEADERS
# include <string.h>
#endif

#include <SWI-Prolog.h>
#include <robolog.h>

#include "swi-robolog.h"

void
prolog_behave() 
{
        predicate_t pred = PL_predicate("behave", 0, "user");
        // JAN:
        qid_t be = PL_open_query(0, PL_Q_NORMAL, pred, 0);
        PL_next_solution(be);
        PL_close_query(be);
        // Original
        //        PL_call_predicate(0, PL_Q_NORMAL, pred, 0);
}

static const PL_extension predicates[] =
{
/*{ "name",             arity, function,                PL_FA_<flags> },*/
{ "angle_to_from_body",         3,      pl_angle_to_from_body,           0 },
{ "angle_to_from_neck",         3,      pl_angle_to_from_neck,           0 },
{ "announce_positions",         0,      pl_announce_positions,   	0 },
{ "at_pos",                	2,      pl_at_pos_2,              	0 },
{ "at_pos",                	3,      pl_at_pos_3,              	0 },
{ "at_pos",                	5,      pl_at_pos_5,              	0 },
{ "ball_absolute_heading", 	1,      pl_ball_absolute_heading,	0 },
{ "ball_absolute_position",	2,      pl_ball_absolute_position,	0 },
{ "ball_absolute_velocity",	2,      pl_ball_absolute_velocity,	0 },
{ "ball_angle_from_body",  	1,      pl_ball_angle_from_body, 	0 },
{ "ball_angle_from_neck",  	1,      pl_ball_angle_from_neck, 	0 },
{ "ball_catchable",         	0,      pl_ball_catchable,       	0 },
{ "ball_distance",         	1,      pl_ball_distance,        	0 },
{ "ball_kick_rate",         	1,      pl_ball_kick_rate,     	        0 },
{ "ball_kickable",         	0,      pl_ball_kickable,               0 },
{ "ball_kickable_for_player",   3,      pl_ball_kickable_for_player,    0 },
{ "ball_moving",         	0,      pl_ball_moving,                 0 },
{ "ball_path_intercept_am_i_there",0,   pl_ball_path_intercept_am_i_there,0 },
{ "ball_path_intercept_am_i_there",1,   pl_ball_path_intercept_am_i_there_1,0},
{ "ball_path_intercept_can_i_get_there",0,
                                  pl_ball_path_intercept_can_i_get_there,0 },
{ "ball_path_intercept_can_i_get_there",1,
                                  pl_ball_path_intercept_can_i_get_there_1,0 },
{ "ball_path_intercept_cycles_for_ball",1,
                                  pl_ball_path_intercept_cycles_for_ball,  0 },
{ "ball_path_intercept_distance",   1, pl_ball_path_intercept_distance,    0 },
{ "ball_path_intercept_point",      2, pl_ball_path_intercept_point,       0 },
{ "ball_path_intercept_valid",      0, pl_ball_path_intercept_valid,       0 },
{ "ball_position_valid",   	0,     pl_ball_position_valid0, 	0 },
{ "ball_position_valid",   	1,     pl_ball_position_valid1, 	0 },
{ "ball_possessor",   	            1, pl_ball_possessor_1, 	          0 },
{ "ball_possessor",   	            2, pl_ball_possessor_2, 	          0 },
{ "ball_relative_to_body_heading",  1, pl_ball_relative_to_body_heading  ,0 },
{ "ball_relative_to_body_position", 2, pl_ball_relative_to_body_position ,0 },
{ "ball_relative_to_body_velocity", 2, pl_ball_relative_to_body_velocity ,0 },
{ "ball_relative_to_neck_heading",  1, pl_ball_relative_to_neck_heading  ,0 },
{ "ball_relative_to_neck_position", 2, pl_ball_relative_to_neck_position ,0 },
{ "ball_relative_to_neck_velocity", 2, pl_ball_relative_to_neck_velocity ,0 },
{ "ball_speed",            	1,     pl_ball_speed,           	0 },
{ "ball_velocity_valid",	0,     pl_ball_velocity_valid0,  	0 },
{ "ball_velocity_valid",	1,     pl_ball_velocity_valid1,  	0 },
{ "ball_x",            	        1,     pl_ball_x,                	0 },
{ "ball_y",            	        1,     pl_ball_y,           	        0 },
{ "best_kick_mode",             2,     pl_best_kick_mode,               0 },
{ "best_kick_mode_abs",         2,     pl_best_kick_mode_abs,           0 },
{ "can_face_ball_with_neck",    0,     pl_can_face_ball_with_neck,      0 },
{ "can_see_ball_with_neck",     0,     pl_can_see_ball_with_neck,       0 },
{ "change_view",           	2,     pl_change_view,          	0 },
// JAN
{ "closest_opponent_to_ball",   1,     pl_closest_opponent_to_ball,     0 },
{ "closest_teammate_to_ball",   2,     pl_closest_teammate_to_ball,     0 },
{ "dash",                  	1,     pl_dash,                 	0 },
{ "direction_quality",          3,     pl_direction_quality,    	0 },
{ "disconnect",                 0,     pl_disconnect,                 	0 },
{ "distance_to",                3,     pl_distance_to,                	0 },
{ "dribble_to",                 4,     pl_dribble_to_4,                	0 },
{ "estimated_cycles_to_steal",  2,     pl_estimated_cycles_to_steal_2, 	0 },
{ "face_neck_and_body_to_ball", 0,     pl_face_neck_and_body_to_ball,   0 },
{ "face_neck_to_ball",          0,     pl_face_neck_to_ball,            0 },
{ "face_only_body_to_ball",     0,     pl_face_only_body_to_ball,       0 },
{ "face_only_neck_to_ball",     0,     pl_face_only_neck_to_ball,       0 },
{ "face_neck_and_body_to_player", 2,   pl_face_neck_and_body_to_player, 0 },
{ "face_neck_to_player",          2,   pl_face_neck_to_player,          0 },
{ "face_only_body_to_player",     2,   pl_face_only_body_to_player,     0 },
{ "face_only_neck_to_player",     2,   pl_face_only_neck_to_player,     0 },
{ "fastest_teammate_to_ball",   1,     pl_fastest_teammate_to_ball,    	0 },
{ "fastest_opponent_to_ball",   1,     pl_fastest_opponent_to_ball,    	0 },
{ "get_ball",              	0,     pl_get_ball,             	0 },
{ "get_ball",              	1,     pl_get_ball_1,             	0 },
{ "get_his_name",		2,	pl_get_his_name,		0 },
{ "get_my_name",		1,	pl_get_my_name,			0 },
{ "go_to_point",                5,     pl_go_to_point,          	0 },
{ "go_to_static_ball",          1,      pl_go_to_static_ball,    	 0 },
{ "goalie_catch",          	1,      pl_goalie_catch,         	 0 },
{ "goalie_number",          	1,      pl_goalie_number,         	 0 },
{ "goalie_number",          	2,      pl_goalie_number_2,         	 0 },
{ "hear",	             	1,      pl_hear,             	 	0 },
{ "hold_ball",             	0,      pl_hold_ball,             	 0 },
{ "in_offside_position",   	0,      pl_in_offside_position,  	 0 },
{ "is_opponent_behind",         2,      pl_is_opponent_behind_2,         0 },
{ "is_opponent_behind",         3,      pl_is_opponent_behind_3,         0 },
{ "is_opponent_behind_from_body",1,     pl_is_opponent_behind_from_body, 0 },
{ "is_opponent_behind_from_neck",1,     pl_is_opponent_behind_from_neck, 0 },
{ "is_player_behind",           3,      pl_is_player_behind_3,           0 },
{ "is_player_behind",           4,      pl_is_player_behind_4,           0 },
{ "is_player_behind_from_body", 2,      pl_is_player_behind_from_body,   0 },
{ "is_player_behind_from_neck", 2,      pl_is_player_behind_from_neck,   0 },
{ "is_point_behind",            3,      pl_is_point_behind_3,           0 },
{ "is_point_behind",            4,      pl_is_point_behind_4,           0 },
{ "is_point_behind_body",  2,      pl_is_point_behind_body,   0 },
{ "is_point_behind_neck",  2,      pl_is_point_behind_neck,   0 },
{ "is_straight_kick",           3,      pl_is_straight_kick,            0 },
{ "is_teammate_behind",         2,      pl_is_teammate_behind_2,        0 },
{ "is_teammate_behind",         3,      pl_is_teammate_behind_3,        0 },
{ "is_teammate_behind_from_body",1,     pl_is_teammate_behind_from_body,0 },
{ "is_teammate_behind_from_neck",1,     pl_is_teammate_behind_from_neck,0 },
{ "kick",                  	2,     pl_kick,                 	0 },
{ "kick_ball",                   4,     pl_kick_ball,                 	0 },
{ "kick_in_progress",            0,     pl_kick_in_progress,            0 },
{ "kqml_hear",			7,	pl_kqml_hear,			0 },
{ "kqml_say",			7,	pl_kqml_say,			0 },
{ "last_team_in_possession",    1,     pl_last_team_in_possession,      0 },
{ "location_side",              3,     pl_location_side,	        0 },
//JAN
{ "log_action",                 2,     pl_log_action,                   0 },
{ "marker_distance",            2,     pl_marker_distance,             	0 },
{ "marker_distance_sqr",        2,     pl_marker_distance_sqr,         	0 },
{ "marker_angle_from_body",     2,     pl_marker_angle_from_body,      	0 },
{ "marker_angle_from_neck",     2,     pl_marker_angle_from_neck,      	0 },
{ "marker_position",            3,     pl_marker_position,             	0 },
{ "marker_x",                   2,     pl_marker_x,                    	0 },
{ "marker_y",                   2,     pl_marker_y,                    	0 },
{ "marker_position_valid",      1,     pl_marker_position_valid1,      	0 },
{ "marker_position_valid",      2,     pl_marker_position_valid2,      	0 },
{ "move",                  	2,     pl_move,                 	0 },
{ "my_body_ang",         	1,     pl_my_body_ang,                  0 },
{ "my_conf",         	        0,     pl_my_conf0,                   	0 },
{ "my_conf",         	        1,     pl_my_conf1,                   	0 },
{ "my_dir",         	        1,     pl_my_dir,               	0 },
{ "my_effort",         	        1,     pl_my_effort,               	0 },
{ "my_goal_marker",        	1,     pl_my_goal_marker,       	0 },
{ "my_location_side",      	1,     pl_my_location_side,     	0 },
{ "my_neck_global_ang",    	1,     pl_my_neck_global_ang,   	0 },
{ "my_neck_rel_ang",       	1,     pl_my_neck_rel_ang,      	0 },
{ "my_number",         	        1,     pl_my_number,            	0 },
{ "my_offside_line",            1,     pl_my_offside_line,      	0 },
{ "my_pos",                	2,     pl_my_pos,               	0 },
{ "my_recovery",                1,     pl_my_recovery,               	0 },
{ "my_score",         	        1,     pl_my_score,             	0 },
{ "my_side",         	        1,     pl_my_side,             	        0 },
{ "my_speed",         	        1,     pl_my_speed,                   	0 },
{ "my_stamina",                 1,     pl_my_stamina,               	0 },
{ "my_team_name",               1,     pl_my_team_name,               	0 },
{ "my_team_name_len",           1,     pl_my_team_name_len,           	0 },
{ "my_vel",                     2,     pl_my_vel,                       0 },
{ "my_vel_conf",                1,     pl_my_vel_conf,                  0 },
{ "my_view_angle",         	1,     pl_my_view_angle,        	0 },
{ "my_x",                       1,     pl_my_x,                         0 },
{ "my_y",                       1,     pl_my_y,                         0 },
// JAN: return the current time        
{ "now",                        1,     pl_now,                          0 },
{ "num_opponents_closer_to_ball",1,    pl_num_opponents_closer_to_ball, 0 },
{ "num_opponents_in_cone",      6,     pl_num_opponents_in_cone,        0 },
{ "num_opponents_within",       2,     pl_num_opponents_within_2,       0 },
{ "num_opponents_within",       4,     pl_num_opponents_within_4,       0 },
{ "num_players_within",         2,     pl_num_players_within_2,         0 },
{ "num_players_within",         4,     pl_num_players_within_4,         0 },
{ "num_teammates_closer_to_ball",1,    pl_num_teammates_closer_to_ball, 0 },
{ "num_teammates_in_cone",      6,     pl_num_teammates_in_cone,        0 },
{ "num_teammates_within",       2,     pl_num_teammates_within_2,       0 },
{ "num_teammates_within",       4,     pl_num_teammates_within_4,       0 },
{ "opponent_in_offside_position",1,    pl_opponent_in_offside_position, 0 },
{ "pass_ball",             	2,     pl_pass_ball,            	0 },
{ "play_mode",             	1,     pl_play_mode,            	0 },
{ "player_absolute_body_angle",	3,     pl_player_absolute_body_angle,  	0 },
{ "player_absolute_neck_angle", 3,     pl_player_absolute_neck_angle,   0 },
{ "player_absolute_position",	4,      pl_player_absolute_position,    0 },
{ "player_absolute_velocity",   4,     pl_player_absolute_velocity,     0 },
{ "player_angle_from_body",	3,     pl_player_angle_from_body,	0 },
{ "player_angle_from_neck",	3,     pl_player_angle_from_neck,	0 },
{ "player_body_angle_valid",	2,     pl_player_body_angle_valid2,	0 },
{ "player_body_angle_valid",	3,     pl_player_body_angle_valid3,	0 },
{ "player_distance",       	3,     pl_player_distance,      	0 },
{ "player_distance_to",       	5,     pl_player_distance_to,      	0 },
{ "player_in_offside_position", 2,     pl_player_in_offside_position,   0 },
{ "player_interception_cycles", 3,     pl_player_interception_cycles_maxp, 0 },
{ "player_interception_cycles", 4,     pl_player_interception_cycles,	   0 },
{ "player_interception_dash_power",3,pl_player_interception_dash_power_maxp,0},
{ "player_interception_dash_power",4,pl_player_interception_dash_power,	   0 },
{ "player_interception_point",  4,     pl_player_interception_point_maxp,  0 },
{ "player_interception_point",  5,     pl_player_interception_point,       0 },
{ "player_interception_result", 3,     pl_player_interception_result_maxp, 0 },
{ "player_interception_result", 4,     pl_player_interception_result,      0 },
{ "player_interceptionable",    2,     pl_player_interceptionable_maxp, 0 },
{ "player_interceptionable",    3,     pl_player_interceptionable,      0 },
{ "player_neck_angle_valid",    2,     pl_player_neck_angle_valid2,    	0 },
{ "player_neck_angle_valid",    3,     pl_player_neck_angle_valid3,    	0 },
{ "player_position_valid",	2,
          pl_player_position_valid2, PL_FA_NONDETERMINISTIC },
{ "player_position_valid",	3,
          pl_player_position_valid3, PL_FA_NONDETERMINISTIC },
{ "player_relative_neck_angle",	3,     pl_player_relative_neck_angle,  	0 },
{ "player_relative_to_body_body_angle", 3,
          pl_player_relative_to_body_body_angle, 0 },
{ "player_relative_to_body_neck_angle", 3,
          pl_player_relative_to_body_neck_angle, 0 },
{ "player_relative_to_body_heading", 3, pl_player_relative_to_body_heading, 0},
{ "player_relative_to_body_position",4, pl_player_relative_to_body_position,0},
{ "player_relative_to_body_velocity",4, pl_player_relative_to_body_velocity,0},
{ "player_relative_to_neck_body_angle", 3,
          pl_player_relative_to_neck_body_angle, 0 },
{ "player_relative_to_neck_neck_angle", 3,
          pl_player_relative_to_neck_neck_angle, 0 },
{ "player_relative_to_neck_position",4, pl_player_relative_to_neck_position,0},
{ "player_relative_to_neck_velocity",4, pl_player_relative_to_neck_velocity,0},
{ "player_speed",         	3,     pl_player_speed,         	0 },
{ "player_velocity_valid",      2,     pl_player_velocity_valid2,	0 },
{ "player_velocity_valid",      3,     pl_player_velocity_valid3,	0 },
{ "player_x",         	        3,     pl_player_x,             	0 },
{ "player_y",         	        3,     pl_player_y,             	0 },
{ "ray_circle_intersect",       7,     pl_ray_circle_intersect_7,	0 },
{ "say",             	        1,     pl_say,                   	0 },
{ "scan_field_with_body",       0,     pl_scan_field_with_body,         0 },
{ "scan_field_with_neck",       0,     pl_scan_field_with_neck,  	0 },
{ "smart_dribble_to",           3,     pl_smart_dribble_to_3,     	0 },
{ "smart_dribble_to",           4,     pl_smart_dribble_to_4,     	0 },
{ "smart_kick_hard",            2,     pl_smart_kick_hard_2,      	0 },
{ "smart_kick_hard",            3,     pl_smart_kick_hard_3,      	0 },
{ "smart_kick_hard",            4,     pl_smart_kick_hard_4,      	0 },
{ "smart_kick_hard_abs",        2,     pl_smart_kick_hard_abs_2,   	0 },
{ "smart_kick_hard_abs",        3,     pl_smart_kick_hard_abs_3,   	0 },
{ "smart_kick_hard_abs",        4,     pl_smart_kick_hard_abs_4,        0 },
{ "smart_pass",                 2,     pl_smart_pass_2,      	        0 },
{ "smart_pass",                 3,     pl_smart_pass_3,      	        0 },
{ "smart_pass",                 4,     pl_smart_pass_4,      	        0 },
{ "smart_pass",                 5,     pl_smart_pass_5,      	        0 },
{ "stop_ball",             	0,     pl_stop_ball,             	0 },
{ "team_in_possession",         1,     pl_team_in_possession_1,         0 },
{ "team_with_ball",             1,     pl_team_with_ball,               0 },
{ "teammate_in_offside_position",1,    pl_teammate_in_offside_position, 0 },
{ "test_go_to_ball",       	0,     pl_test_go_to_ball,      	0 },
{ "test_go_to_point",       	4,     pl_test_go_to_point,      	0 },
{ "test_kick",                  0,     pl_test_kick,                   	0 },
{ "test_kick_2",                0,     pl_test_kick_2,          	0 },
{ "test_random_movement",  	0,     pl_test_random_movement, 	0 },
{ "their_goal_marker",          1,     pl_their_goal_marker,    	0 },
{ "their_offside_line",         1,     pl_their_offside_line,      	0 },
{ "their_score",                1,     pl_their_score,          	0 },
{ "their_side",                 1,     pl_their_side,          	        0 },
{ "their_team_name",            1,     pl_their_team_name,     	        0 },
{ "tired",             	        0,     pl_tired,                 	0 },
{ "turn",                  	1,     pl_turn,                 	0 },
{ "turn_neck",             	1,     pl_turn_neck,            	0 },
{ "vel_at_pt_2_vel_at_foot",    4,     pl_vel_at_pt_2_vel_at_foot,      0 },
{ 0, 0, 0, 0 }	/* terminating line */
};

const int n_marker = 56;
const int n_kick_modes = 6;
const int n_turn_dirs = 5;

int p_argc;
char **p_argv;
atom_t a_marker[n_marker];
atom_t a_kick_modes[n_kick_modes];
atom_t a_turn_dirs[n_turn_dirs];

int
main(int argc, char **argv)
{
        char *program = argv[0];
        char *plav[2];

        p_argc = argc;
	p_argv = argv;
        
        // create prolog argument vector
        plav[0] = program;
        plav[1] = 0;
        
        PL_register_extensions(predicates);

        if (!PL_initialise(argc, argv))
                PL_halt(1);

	install_marker_atoms();
        install_kick_mode_atoms();
        install_turn_dir_atoms();
        
	rsc_main(argc, argv);
        
        PL_halt(0);
}


void
install_marker_atoms()
{
	const char *atoms[] = 
{ "goal_l",   "goal_r",   "flag_c",   "flag_ct",  "flag_cb",  "flag_lt",
  "flag_lb",  "flag_rt",  "flag_rb",  "flag_plt", "flag_plc", "flag_plb",
  "flag_prt", "flag_prc", "flag_prb", "flag_glt", "flag_glb", "flag_grt",
  "flag_grb", "flag_tl50","flag_tl40","flag_tl30","flag_tl20","flag_tl10",
  "flag_t0",  "flag_tr10","flag_tr20","flag_tr30","flag_tr40","flag_tr50",
  "flag_bl50","flag_bl40","flag_bl30","flag_bl20","flag_bl10","flag_b0",
  "flag_br10","flag_br20","flag_br30","flag_br40","flag_br50","flag_lt30",
  "flag_lt20","flag_lt10","flag_l0",  "flag_lb10","flag_lb20","flag_lb30",
  "flag_rt30","flag_rt20","flag_rt10","flag_r0",  "flag_rb10","flag_rb20",
  "flag_rb30","no_marker" };
  
 	for (int i=0; i<n_marker; i++)
		a_marker[i] = PL_new_atom(atoms[i]);
}


void
install_kick_mode_atoms()
{
        const char *atoms[] =
{ "none", "hardest", "hard", "moderate", "quickly", "quickest" };
        
        for (int i=0; i<n_kick_modes; i++)
                a_kick_modes[i] = PL_new_atom(atoms[i]);
}

void
install_turn_dir_atoms()
{
        const char *atoms[] =
{ "none", "clockwise", "counterclockwise", "closest", "avoid" };
        
        for (int i=0; i<n_turn_dirs; i++)
                a_turn_dirs[i] = PL_new_atom(atoms[i]);
}


bool
PL_get_marker(term_t t_marker, MarkerType *m)
{
	atom_t a;

	PL_get_atom(t_marker, &a);

        int i = 0;
	*m = No_Marker;

	while ((i < n_marker) && (*m == No_Marker)) {
		if (a == a_marker[i]) *m = MarkerType(i);
		i++;
	}

	return (*m != No_Marker);
}


bool
PL_get_kick_mode(term_t t_mode, KickMode *m)
{
        atom_t a;
        PL_get_atom(t_mode, &a);
        int i = n_kick_modes;
        *m = KM_None;

        while (i >= 0 && *m == KM_None) {
                if (a == a_kick_modes[i]) *m = KickMode(i);
                i--;
        }
        return (*m != KM_None);
}


bool
PL_get_turn_dir(term_t t_mode, TurnDir *td)
{
        atom_t a;
        *td = TURN_NONE;
        if (PL_get_atom(t_mode, &a)) {
                int i = n_turn_dirs;

                while (i >= 0 && *td == TURN_NONE) {
                        if (a == a_turn_dirs[i]) *td = TurnDir(i);
                        i--;
                }
        }
        return (*td != TURN_NONE);
}


bool
PL_get_side(term_t t_side, char *s)
{
        char *s_side;

        if (PL_get_atom_chars(t_side, &s_side) &&
            ((s_side[0] == 'l') || (s_side[0] == 'r'))) {
                *s = s_side[0];
                return true;
        }
        
        *s = ' ';
        return false;
}


bool
PL_unify_kick_mode(term_t t_mode, KickMode m)
{
        if (PL_unify_atom(t_mode, a_kick_modes[int(m)])) return true;
        return PL_unify_atom(t_mode, a_kick_modes[0]);
}


bool
PL_unify_position(term_t t_x, term_t t_y, char s, Unum n)
{
        float x;
        float y;
        
        rsc_player_absolute_position(s, n, &x, &y);
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


bool
PL_unify_dribble_res(term_t t_drib_res, DribbleRes drib_res)
{
        switch (drib_res) {
        case DR_Error : 
                return PL_unify_atom_chars(t_drib_res, "error");
        case DR_LostBall : 
                return PL_unify_atom_chars(t_drib_res, "lost_ball");
        case DR_GotThere : 
                return PL_unify_atom_chars(t_drib_res, "got_there");
        case DR_Going : 
                return PL_unify_atom_chars(t_drib_res, "going");
        default :
                return PL_unify_atom_chars(t_drib_res, "none");
        }
}


int
chr2saychr(unsigned char c, char s[4]) 
{
        static const char digit[] =
        { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
          'A', 'B', 'C', 'D', 'E', 'F' };

        if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') ||
            (c >= '0' && c <= '9') || (strchr(" ().+-*/<>_", c))) {
                s[0] = c;
                s[1] = 0;
                return 1;
        } else {
                s[0] = '?';
                s[1] = digit[c / 16];
                s[2] = digit[c % 16];
                s[3] = 0;
                return 3;
        }
}

#ifdef __cplusplus
extern "C" {
# if 0 // only to switch off stupid xemacs indenting
}
# endif
#endif

foreign_t
pl_angle_to_from_body(term_t t_x, term_t t_y, term_t t_angle)
{
        double x,y;
        
	if (!PL_get_float(t_x, &x)) {
	        cerr << ERR_FLOAT_EXPECTED
                     << "angle_to_from_body/2" << endl;
                PL_fail;
        }

	if (!PL_get_float(t_y, &y)) {
	        cerr << ERR_FLOAT_EXPECTED
                     << "angle_to_from_body/2" << endl;
                PL_fail;
        }

        return PL_unify_float(t_angle, rsc_angle_to_from_body(x,y));
}

foreign_t
pl_angle_to_from_neck(term_t t_x, term_t t_y, term_t t_angle)
{
        double x,y;
        
	if (!PL_get_float(t_x, &x)) {
	        cerr << ERR_FLOAT_EXPECTED
                     << "angle_to_from_neck/2" << endl;
                PL_fail;
        }

	if (!PL_get_float(t_y, &y)) {
	        cerr << ERR_FLOAT_EXPECTED
                     << "angle_to_from_neck/2" << endl;
                PL_fail;
        }

        return PL_unify_float(t_angle, rsc_angle_to_from_neck(x,y));
}

foreign_t
pl_announce_positions()
{
        rsc_announce_positions();
        PL_succeed;
}

foreign_t
pl_at_pos_2(term_t t_x, term_t t_y)
{
        double x,y;
        
	if (!PL_get_float(t_x, &x)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/2" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/2" << endl;
                PL_fail;
        }

        if (rsc_at_pos_2(x,y)) PL_succeed;
        PL_fail;
}

foreign_t
pl_at_pos_3(term_t t_x, term_t t_y, term_t t_buf)
{
        double x,y;
        double buffer;
        
	if (!PL_get_float(t_x, &x)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/3" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/3"  << endl;
                PL_fail;
        }

        if (!PL_get_float(t_buf, &buffer)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/3" << endl;
                PL_fail;
        }

        if (rsc_at_pos_3(x,y,buffer)) PL_succeed;
        PL_fail;
}

        
foreign_t
pl_at_pos_5(term_t t_x0, term_t t_y0, term_t t_x1, term_t t_y1, term_t t_buf)
{
        double x0,y0;
        double x1,y1;
        double buffer;
        
	if (!PL_get_float(t_x0, &x0)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/5 - 1" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y0, &y0)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/5 - 2"  << endl;
                PL_fail;
        }

	if (!PL_get_float(t_x1, &x1)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/5 - 3" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y1, &y1)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/5 - 4"  << endl;
                PL_fail;
        }

        if (!PL_get_float(t_buf, &buffer)) {
	        cerr << ERR_FLOAT_EXPECTED <<"at_pos/5 - 5" << endl;
                PL_fail;
        }

        if (rsc_at_pos_5(x0, y0, x1, y1, buffer)) PL_succeed;
        PL_fail;
}

        
foreign_t
pl_ball_absolute_heading(term_t t_ang)
{
        return PL_unify_float(t_ang, rsc_ball_absolute_heading());
}


foreign_t
pl_ball_absolute_position(term_t t_x, term_t t_y)
{
        float x, y;
        rsc_ball_absolute_position(&x, &y);
        
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


foreign_t
pl_ball_absolute_velocity(term_t t_x, term_t t_y)
{
        float x, y;
        rsc_ball_absolute_velocity(&x, &y);
        
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


foreign_t
pl_ball_angle_from_body(term_t t_ang)
{
        return PL_unify_float(t_ang, rsc_ball_angle_from_body());
}


foreign_t
pl_ball_angle_from_neck(term_t t_ang)
{
        return PL_unify_float(t_ang, rsc_ball_angle_from_neck());
}


foreign_t
pl_ball_catchable()
{
        if (rsc_ball_catchable()) PL_succeed;
	PL_fail;
}


foreign_t
pl_ball_distance(term_t t_dist)
{
        return PL_unify_float(t_dist, rsc_ball_distance());
}


foreign_t
pl_ball_kick_rate(term_t t_rate)
{
        return PL_unify_float(t_rate, rsc_ball_kick_rate());
}


foreign_t
pl_ball_kickable()
{
        if (rsc_ball_kickable())
                PL_succeed;
        else
                PL_fail;
}


foreign_t
pl_ball_kickable_for_player(term_t t_side, term_t t_unum, term_t t_buffer)
{
        char s;
        Unum unum;
        double buffer;

        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "ball_kickable_for_player/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) || (unum > rsc_SP_team_size()) ||
	    (unum < 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"ball_kickable_for_player/3"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}
	 
	if (!PL_get_float(t_buffer, &buffer)) {
	        cerr << ERR_FLOAT_EXPECTED <<"ball_kickable_for_player/3"  << endl;
                PL_fail;
	}
	        
        if (rsc_ball_kickable(s, unum, buffer)) PL_succeed;
	PL_fail;
}


foreign_t
pl_ball_moving()
{
        if (rsc_ball_moving()) PL_succeed;
	PL_fail;
}

foreign_t
pl_ball_path_intercept_am_i_there()
{
        if (rsc_ball_path_intercept_am_i_there()) PL_succeed;
        PL_fail;
}

foreign_t
pl_ball_path_intercept_am_i_there_1(term_t t_buffer)
{
        double buffer;

	if (!PL_get_float(t_buffer, &buffer)) {
	        cerr << ERR_FLOAT_EXPECTED <<
                           "ball_path_intercept_am_i_there/1" << endl;
                PL_fail;
        }
         
        if (rsc_ball_path_intercept_am_i_there_1(buffer)) PL_succeed;
        PL_fail;
}

foreign_t
pl_ball_path_intercept_can_i_get_there()
{
        if (rsc_ball_path_intercept_can_i_get_there()) PL_succeed;
        PL_fail;
}

foreign_t
pl_ball_path_intercept_can_i_get_there_1(term_t t_power)
{
        double power;

	if (!PL_get_float(t_power, &power)) {
	        cerr << ERR_FLOAT_EXPECTED <<
                           "ball_path_intercept_can_i_get_there/1"  << endl;
                PL_fail;
        }
         
        if (rsc_ball_path_intercept_can_i_get_there_1(power)) PL_succeed;
        PL_fail;
}

foreign_t
pl_ball_path_intercept_cycles_for_ball(term_t t_cycles)
{
        return PL_unify_float(t_cycles,
                              rsc_ball_path_intercept_cycles_for_ball());
}

foreign_t
pl_ball_path_intercept_distance(term_t t_dist)
{
        return PL_unify_float(t_dist, rsc_ball_path_intercept_distance());
}

foreign_t
pl_ball_path_intercept_point(term_t t_x, term_t t_y)
{
        float x, y;
	rsc_ball_path_intercept_point(&x, &y);
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}

foreign_t
pl_ball_path_intercept_valid()
{
        if (rsc_ball_path_intercept_valid()) PL_succeed;
        PL_fail;
}

foreign_t
pl_ball_position_valid0()
{
        if (rsc_ball_position_valid()) PL_succeed;
        PL_fail;
}

foreign_t
pl_ball_position_valid1(term_t t_conf)
{
        return PL_unify_float(t_conf, rsc_ball_position_valid());
}

foreign_t
pl_ball_possessor_1(term_t t_unum)
{
        return PL_unify_integer(t_unum, abs(rsc_ball_possessor()));
}

foreign_t
pl_ball_possessor_2(term_t t_unum, term_t t_side)
{
        char *side = "?";
        Unum num = rsc_ball_possessor();
 
        if (num == 0)
                PL_fail;

        side[0] = num > 0 ? rsc_my_side() : rsc_their_side();
        
        return PL_unify_integer(t_unum, abs(num)) == 0 ? 0 :
                PL_unify_atom_chars(t_side, side);
}

foreign_t
pl_ball_relative_to_body_heading(term_t t_ang)
{
        return PL_unify_float(t_ang, rsc_ball_relative_to_body_heading());
}	


foreign_t
pl_ball_relative_to_body_position(term_t t_x, term_t t_y)
{
        float x, y;
	rsc_ball_relative_to_body_position(&x, &y);

        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}	


foreign_t
pl_ball_relative_to_body_velocity(term_t t_x, term_t t_y)
{
        float x, y;
	rsc_ball_relative_to_body_velocity(&x, &y);

        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}	


foreign_t
pl_ball_relative_to_neck_heading(term_t t_ang)
{
        return PL_unify_float(t_ang, rsc_ball_relative_to_neck_heading());
}	


foreign_t
pl_ball_relative_to_neck_position(term_t t_x, term_t t_y)
{
        float x, y;
	rsc_ball_relative_to_neck_position(&x, &y);

        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}	


foreign_t
pl_ball_relative_to_neck_velocity(term_t t_x, term_t t_y)
{
        float x, y;
	rsc_ball_relative_to_neck_velocity(&x, &y);

        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}	


foreign_t
pl_ball_speed(term_t t_speed)
{
        return PL_unify_float(t_speed, rsc_ball_speed());
}


foreign_t
pl_ball_velocity_valid0()
{
        if (rsc_ball_velocity_valid()) PL_succeed;
	PL_fail;
}


foreign_t
pl_ball_velocity_valid1(term_t t_conf)
{
        return PL_unify_float(t_conf, rsc_ball_velocity_valid());
}


foreign_t
pl_ball_x(term_t t_x)
{
        return PL_unify_float(t_x, rsc_ball_x());
}


foreign_t
pl_ball_y(term_t t_y)
{
        return PL_unify_float(t_y, rsc_ball_y());
}


foreign_t
pl_best_kick_mode(term_t t_ang, term_t t_kick_mode)
{
        double ang;
        
	if (!PL_get_float(t_ang, &ang)) {
	        cerr << ERR_FLOAT_EXPECTED <<"best_kick_mode/2"  << endl;
                PL_fail;
        }
        
        return PL_unify_kick_mode(t_kick_mode,
                                  rsc_best_kick_mode(ang));
}


foreign_t
pl_best_kick_mode_abs(term_t t_ang, term_t t_kick_mode)
{
        double ang;
        
	if (!PL_get_float(t_ang, &ang)) {
	        cerr << ERR_FLOAT_EXPECTED <<"best_kick_mode_abs/2"  << endl;
                PL_fail;
        }
        
        return PL_unify_kick_mode(t_kick_mode,
                                  rsc_best_kick_mode_abs(ang));
}


foreign_t
pl_can_face_ball_with_neck()
{
        if (rsc_can_face_ball_with_neck()) PL_succeed;
	PL_fail;
}


foreign_t
pl_can_see_ball_with_neck()
{
        if (rsc_can_see_ball_with_neck()) PL_succeed;
	PL_fail;
}


foreign_t
pl_change_view(term_t t_qual, term_t t_width)
{
        char *s_qual; 
        char *s_width;

        Vqual qual;
        Vwidth width;
        
        PL_get_atom_chars(t_qual, &s_qual);
        PL_get_atom_chars(t_width, &s_width);

        if (strlen(s_qual) < 3 || strlen(s_width) < 4) {
                cerr << "syntax." << endl;
                PL_fail;
        } else {
                switch (s_qual[0]) {
                case 'l':
                        qual = VQ_Low;
                        break;
                case 'h':
                        qual = VQ_High;
                        break;
                default:
                        cerr << "syntax" << endl;
                        PL_fail;
                }

                switch(s_width[1]) {
                case 'a':
                        width = VW_Narrow;
                        break;
                case 'o':
                        width = VW_Normal;
                        break;
                case 'i' :
                        width = VW_Wide;
                        break;
                default:
                        cerr << "syntax" << endl;
                        PL_fail;
                }
                
        }
                
        rsc_change_view(qual,width);
        PL_succeed;
}

foreign_t
pl_closest_opponent_to_ball(term_t t_unum)
{
        return PL_unify_integer(t_unum, rsc_closest_opponent_to_ball());
}

foreign_t
pl_closest_teammate_to_ball(term_t t_who, term_t t_unum )
{
        char *who;

        if (!PL_get_chars(t_who, &who, CVT_ALL|BUF_DISCARDABLE)) {
                cerr << "closest_teammate_to_ball/2: "
                        "You must provide a mode (all/other)" << endl;
		PL_fail;
        }
        return PL_unify_integer(t_unum, rsc_closest_teammate_to_ball(who[0]=='a'));
        // return PL_unify_integer(t_unum, rsc_closest_teammate_to_ball(false));
}

foreign_t
pl_dash(term_t t_power)
{
        double power;

        PL_get_float(t_power, &power);
        rsc_dash(power);
        PL_succeed;
}


foreign_t
pl_direction_quality(term_t t_ang, term_t t_sect, term_t t_qual)
{
        double ang;
        int sect;
        
	if (!PL_get_float(t_ang, &ang)) {
	        cerr << ERR_FLOAT_EXPECTED <<"direction_quality/3"  << endl;
                PL_fail;
        }

        if (!PL_get_integer(t_sect, &sect)) {
	        PL_warning(ERR_INT_EXPECTED, "direction_quality/3", 2);
        }
        
        return PL_unify_integer(t_qual, rsc_direction_quality(ang, sect));
}


foreign_t
pl_disconnect()
{
        rsc_disconnect();
	PL_succeed;
}


foreign_t
pl_distance_to(term_t t_x, term_t t_y, term_t t_dist) 
{
        double x,y;
        
	if (!PL_get_float(t_x, &x)) {
	        cerr << ERR_FLOAT_EXPECTED <<"distance_to/2"  << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
	        cerr << ERR_FLOAT_EXPECTED <<"distance_to/2"  << endl;
                PL_fail;
        }

        return PL_unify_float(t_dist, rsc_distance_to(x,y));
}


foreign_t
pl_dribble_to_4(term_t t_x, term_t t_y, term_t t_drib_ang, term_t t_drib_res)
{
        double x,y;
        double ang;
        
        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"dribble_to/4"  << endl;
                PL_fail;
        }
        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"dribble_to/4"  << endl;
                PL_fail;
        }
        if (!PL_get_float(t_drib_ang, &ang)) {
                cerr << ERR_FLOAT_EXPECTED <<"dribble_to/4"  << endl;
                PL_fail;
        }
        return PL_unify_dribble_res(t_drib_res, rsc_dribble_to_3(x,y,ang));
}


foreign_t
pl_estimated_cycles_to_steal_2(term_t t_unum, term_t t_cycles)
{
        Unum unum;
        int cycles;

        if (!PL_get_integer(t_unum, &unum) || (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"estimated_cycles_to_steal/2"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        return PL_unify_integer(t_cycles,
                                rsc_estimated_cycles_to_steal_1(unum));
}

foreign_t
pl_face_neck_and_body_to_ball()
{
        if (rsc_face_neck_and_body_to_ball() == AQ_ActionQueued)
                PL_succeed;
        PL_fail;
}

foreign_t
pl_face_neck_to_ball()
{
        if (rsc_face_neck_to_ball() == AQ_ActionQueued)
                PL_succeed;
        PL_fail;
}

foreign_t
pl_face_only_body_to_ball()
{
        if (rsc_face_only_body_to_ball() == AQ_ActionQueued)
                PL_succeed;
        PL_fail;
}

foreign_t
pl_face_only_neck_to_ball()
{
        rsc_face_only_neck_to_ball();
        PL_succeed;
}

foreign_t
pl_face_neck_and_body_to_player(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;

        if (!PL_get_side(t_side, &s)) {
	        cerr << ERR_SIDE_EXPECTED << "face_neck_and_body_to_player/2"
                     << " - 1" << endl;
                PL_fail;
	}                
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED << "face_neck_and_body_to_player/2 "
                     << rsc_SP_team_size() << " - 2" << endl;
                PL_fail;
	}
        
        if (rsc_face_neck_and_body_to_player(s,unum) == AQ_ActionQueued)
                PL_succeed;
        PL_fail;
}

foreign_t
pl_face_neck_to_player(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;

        if (!PL_get_side(t_side, &s)) {
	        cerr << ERR_SIDE_EXPECTED << "face_neck_to_player/2"
                     << " - 1" << endl;
                PL_fail;
	}                
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED << "face_neck_to_player/2 "
                     << rsc_SP_team_size() << " - 2" << endl;
                PL_fail;
	}
        
        if (rsc_face_neck_to_player(s,unum) == AQ_ActionQueued)
                PL_succeed;
        PL_fail;
}

foreign_t
pl_face_only_body_to_player(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;

        if (!PL_get_side(t_side, &s)) {
	        cerr << ERR_SIDE_EXPECTED << "face_only_body_to_player/2"
                     << " - 1" << endl;
                PL_fail;
	}                
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED << "face_only_body_to_player/2 "
                     << rsc_SP_team_size() << " - 2" << endl;
                PL_fail;
	}
        
        if (rsc_face_only_body_to_player(s,unum) == AQ_ActionQueued)
                PL_succeed;
        PL_fail;
}

foreign_t
pl_face_only_neck_to_player(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;

        if (!PL_get_side(t_side, &s)) {
	        cerr << ERR_SIDE_EXPECTED << "face_only_neck_to_player/2"
                     << " - 1" << endl;
                PL_fail;
	}                
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED << "face_only_neck_to_player/2 "
                     << rsc_SP_team_size() << " - 2" << endl;
                PL_fail;
	}
        
        rsc_face_only_neck_to_player(s,unum);
        PL_succeed;
}

foreign_t
pl_fastest_teammate_to_ball(term_t t_unum)
{
        return PL_unify_integer(t_unum, rsc_fastest_teammate_to_ball());
}

foreign_t
pl_fastest_opponent_to_ball(term_t t_unum)
{
        return PL_unify_integer(t_unum, rsc_fastest_opponent_to_ball());
}


foreign_t
pl_get_ball()
{
        rsc_get_ball_1(false);
        PL_succeed;
}

foreign_t
pl_get_ball_1(term_t t_force)
{
        char *s_force;
        
	PL_get_atom_chars(t_force, &s_force);
        rsc_get_ball_1(strcmp(s_force, "force") == 0);
        PL_succeed;
}

foreign_t
pl_get_his_name(term_t t_His_Number, term_t t_His_Name)
{
	char His_Name[50];
	int His_Number;
	int get_int_flag;
	get_int_flag = PL_get_integer(t_His_Number, &His_Number);
	rsc_get_his_name(His_Number, His_Name);
	return PL_unify_string_chars(t_His_Name, His_Name) && get_int_flag;
}

foreign_t
pl_get_my_name(term_t t_My_Name)
{
	char My_Name[50];
	rsc_get_my_name(My_Name);
	return PL_unify_string_chars(t_My_Name, My_Name);
}

foreign_t
pl_go_to_point(term_t t_x, term_t t_y, term_t t_buffer, 
               term_t t_power, term_t t_dodge)
{
        double x, y;
        double buffer;
        double power;
        char *s_dodge;
	DodgeType dodge;
 
        PL_get_float(t_x, &x);
        PL_get_float(t_y, &y);
        PL_get_float(t_buffer, &buffer);
        PL_get_float(t_power, &power);
	PL_get_atom_chars(t_dodge, &s_dodge);

        if (strlen(s_dodge) < 3) {
                cerr << "syntax" << endl;
                PL_fail;
	} else {
	        switch (s_dodge[0]) {
                case 'a' :
                         dodge = DT_all;
			 break;
                case 'u' :
                         dodge = DT_unless_with_ball;
			 break;
		case 'o' :
		         dodge = DT_only_with_ball;
			 break;
                default :
                         dodge =  DT_none;
                }
                if (rsc_go_to_point(x,y,buffer,power,dodge) == AQ_ActionQueued)
                         PL_succeed;
		else 
		         PL_fail;
	} 
}


foreign_t
pl_go_to_static_ball(term_t t_ang)
{
        double ang;
        
        if (!PL_get_float(t_ang, &ang)) {
                cerr << ERR_FLOAT_EXPECTED <<"go_to_static_ball/1"  << endl;
                PL_fail;
        }
        // JAN: rsc_go_to_static_ball fails if we still have to go and succeeds
        // if we are, where we want to be.
        // But I think, we want the predicate to behave the other way around.
        // So go_to_static_ball/0 succeeds if rsc_go_to_static_ball returns false
        // and vice versa
        if (rsc_go_to_static_ball(ang)) PL_fail;
        PL_succeed;
}


foreign_t
pl_goalie_catch(term_t t_ang)
{
        double ang;

        PL_get_float(t_ang, &ang);
        rsc_goalie_catch(ang);
        PL_succeed;
}

foreign_t
pl_goalie_number(term_t t_unum)
{
        return PL_unify_integer(t_unum, rsc_goalie_number());
}


foreign_t
pl_goalie_number_2(term_t t_side, term_t t_unum)
{
        char s;

        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "goalie_number/2", 1);
                PL_fail;
	}                
        
        return PL_unify_integer(t_unum, rsc_goalie_number_1(s));
}


foreign_t
pl_hear(term_t t_msg)
{
	char msg[1024];
	rsc_hear(msg);
	return PL_unify_string_chars(t_msg, msg);
}


foreign_t
pl_hold_ball()
{
        rsc_hold_ball();
	PL_succeed;
}


foreign_t
pl_in_offside_position()
{
        if (rsc_in_offside_position()) PL_succeed;
        PL_fail;
}


foreign_t
pl_is_opponent_behind_2(term_t t_unum, term_t t_ang)
{
        Unum unum;
        double ang;
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_opponent_behind/2"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (!PL_get_float(t_ang, &ang)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_opponent_behind/2"  << endl;
                PL_fail;
        }

        if (rsc_is_opponent_behind_2(unum, ang)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_opponent_behind_3(term_t t_unum, term_t t_x, term_t t_y)
{
        Unum unum;
        double x,y;
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_opponent_behind/3"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_opponent_behind/3"  << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_opponent_behind/3"  << endl;
                PL_fail;
        }

        if (rsc_is_opponent_behind_3(unum,x,y)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_opponent_behind_from_body(term_t t_unum)
{
        Unum unum;
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_opponent_behind_from_body/1"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (rsc_is_opponent_behind_from_body(unum)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_opponent_behind_from_neck(term_t t_unum)
{
        Unum unum;
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_opponent_behind_from_neck/1"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (rsc_is_opponent_behind_from_neck(unum)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_player_behind_3(term_t t_side, term_t t_unum, term_t t_ang)
{
        char s;
        Unum unum;
        double ang;

        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "is_player_behind/3", 1);
                PL_fail;
	}                
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_player_behind/3"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (!PL_get_float(t_ang, &ang)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_player_behind/3"  << endl;
                PL_fail;
        }
        
        if (rsc_is_player_behind_3(s,unum,ang)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_player_behind_4(term_t t_side, term_t t_unum, term_t t_x, term_t t_y)
{
        char s;
        Unum unum;
        double x,y;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "is_player_behind/4", 1);
                PL_fail;
	}
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_player_behind/4"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_player_behind/4" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_player_behind/4"  << endl;
                PL_fail;
        }

        if (rsc_is_player_behind_4(s,unum,x,y)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_player_behind_from_body(term_t t_side, term_t t_unum)
{
        char s;        
        Unum unum;

        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "is_player_behind_from_body/2",
                           1);
                PL_fail;
	}
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_player_behind_from_body/2"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (rsc_is_player_behind_from_body(s, unum)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_player_behind_from_neck(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;

        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "is_player_behind_from_neck/2",
                           1);
                PL_fail;
	}
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_player_behind_from_neck/2"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (rsc_is_player_behind_from_neck(s, unum)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_point_behind_3(term_t t_x0, term_t t_y0, term_t t_ang)
{
        double x0, y0;
        double ang;

        if (!PL_get_float(t_x0, &x0)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_point_behind/3" << endl;
                PL_fail;
        }
        
        if (!PL_get_float(t_y0, &y0)) {
	        cerr << ERR_FLOAT_EXPECTED <<"is_point_behind/3" << endl;
                PL_fail;
	}                
        
        if (!PL_get_float(t_ang, &ang)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_point_behind/3" << endl;
                PL_fail;
        }
        
        if (rsc_is_point_behind_3(x0,y0,ang)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_point_behind_4(term_t t_x0, term_t t_y0, term_t t_x1, term_t t_y1)
{
        double x0,y0;
        double x1,y1;
        
        if (!PL_get_float(t_x0, &x0)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_point_behind/4" << endl;
                PL_fail;
        }
        
        if (!PL_get_float(t_y0, &y0)) {
	        cerr << ERR_FLOAT_EXPECTED <<"is_point_behind/4" << endl;
                PL_fail;
	}                
        
        if (!PL_get_float(t_x1, &x1)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_point_behind/4" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y1, &y1)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_point_behind/4" << endl;
                PL_fail;
        }

        if (rsc_is_point_behind_4(x0,y0,x1,y1)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_point_behind_body(term_t t_x0, term_t t_y0)
{
        double x0, y0;

        
        if (!PL_get_float(t_x0, &x0)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_point_behind_body/2"
                     << endl;
                PL_fail;
        }
        
        if (!PL_get_float(t_y0, &y0)) {
	        cerr << ERR_FLOAT_EXPECTED <<"is_point_behind_body/4"
                     << endl;   
                PL_fail;
	}                


        if (rsc_is_point_behind_body(x0, y0)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_point_behind_neck(term_t t_x0, term_t t_y0)
{
        double x0, y0;

        
        if (!PL_get_float(t_x0, &x0)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_point_behind_neck/2"
                     << endl;      
                PL_fail;
        }
        
        if (!PL_get_float(t_y0, &y0)) {
	        cerr << ERR_FLOAT_EXPECTED <<"is_point_behind_neck/2"
                     << endl;
                PL_fail;
	}

        if (rsc_is_point_behind_neck(x0, y0)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_straight_kick(term_t t_dir, term_t t_dist, term_t t_buffer)
{
        double dir, dist, buffer;
        
        if (!PL_get_float(t_dir, &dir)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_straight_kick/3"
                     << endl;
                PL_fail;
        }

        if (!PL_get_float(t_dist, &dist)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_straight_kick/3"
                     << endl;
                PL_fail;
        }

        if (!PL_get_float(t_buffer, &buffer)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_straight_kick/3" << endl;
                PL_fail;
        }

        if (rsc_is_straight_kick(dir, dist, buffer)) PL_succeed;
        PL_fail;
}


foreign_t
pl_is_teammate_behind_2(term_t t_unum, term_t t_ang, control_t ctrl)
{
        Unum unum;
        double ang;
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_teammate_behind/2"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (!PL_get_float(t_ang, &ang)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_teammate_behind/2"  << endl;
                PL_fail;
        }

        if (rsc_is_teammate_behind_2(unum, ang)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_teammate_behind_3(term_t t_unum, term_t t_x, term_t t_y)
{
        Unum unum;
        double x,y;
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_teammate_behind/3"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_teammate_behind/3"
                         << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"is_teammate_behind/3"
                         << endl;
                PL_fail;
        }

        if (rsc_is_teammate_behind_3(unum,x,y)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_teammate_behind_from_body(term_t t_unum)
{
        Unum unum;
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_teammate_behind_from_body/1"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (rsc_is_teammate_behind_from_body(unum)) PL_succeed;
        PL_fail;
}

foreign_t
pl_is_teammate_behind_from_neck(term_t t_unum)
{
        Unum unum;
        
        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"is_teammate_behind_from_neck/1"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (rsc_is_teammate_behind_from_neck(unum)) PL_succeed;
        PL_fail;
}

foreign_t
pl_kick(term_t t_power, term_t t_dir)
{
        double power,dir;

        PL_get_float(t_power, &power);
        PL_get_float(t_dir, &dir);
        rsc_kick(power,dir);
        PL_succeed;
}

foreign_t
pl_kick_ball(term_t t_x, term_t t_y, term_t t_mode, term_t t_rot)
{
        double x,y;
        KickMode mode;
        TurnDir rot;
        
        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED << "kick_ball/4 - 1" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED << "kick_ball/4 - 2" << endl;
                PL_fail;
        }

        if (!PL_get_kick_mode(t_mode, &mode)) {
                cerr << ERR_KICKMODE_EXPECTED << "kick_ball/4 - 3" << endl;
                PL_fail;
        }

        if (!PL_get_turn_dir(t_rot, &rot)) {
                cerr << ERR_TURN_DIR_EXPECTED << "kick_ball/4 - 4" << endl;
                PL_fail;
        }
        rsc_kick_ball(x,y,mode,rot);
        PL_succeed;
}

foreign_t pl_kick_in_progress()
{
        if (rsc_kick_in_progress()) PL_succeed;
        PL_fail;
}

foreign_t 
pl_kqml_hear(term_t perft, term_t sendert, term_t recievert, term_t languaget, term_t rwt, term_t irtt, term_t contentt)
{
	char perf[20];
	char content[512];
	char irt[20];
	char language[20];
	char reciever[20];
	char rw[20];
	char sender[20];
	foreign_t test;
	
	rsc_kqml_hear(perf, sender, reciever, language, rw, irt, content);
	test =	PL_unify_string_chars(perft, perf) &&
		PL_unify_string_chars(sendert, sender) &&
		PL_unify_string_chars(recievert, reciever) &&
		PL_unify_string_chars(languaget, language) &&
		PL_unify_string_chars(rwt, rw) &&
		PL_unify_string_chars(irtt, irt) &&
		PL_unify_string_chars(contentt, content);
	return(test);
}

foreign_t 
pl_kqml_say (term_t perft, term_t sendert, term_t recievert, term_t languaget, term_t rwt, term_t irtt, term_t contentt)
{
	char *perf = (char *) malloc( sizeof(char) * 20);
	char *content= (char *) malloc( sizeof(char) * 512);
	char *irt = (char *) malloc( sizeof(char) * 20);
	char *language = (char *) malloc( sizeof(char) * 20);
	char *reciever = (char *) malloc( sizeof(char) * 20);
	char *rw = (char *) malloc( sizeof(char) * 20);
	char *sender = (char *) malloc( sizeof(char) * 20);
	
	bool sflag, lflag, rwflag;
	unsigned long gflag = CVT_ALL | BUF_MALLOC;

	int succflag;

	sflag = PL_is_variable(sendert);
	lflag = PL_is_variable(languaget);
	rwflag= PL_is_variable(rwt);

	succflag = PL_get_chars(perft, &perf, gflag);
	succflag = succflag && PL_get_chars(recievert, &reciever, gflag);
	if (sflag) {sender[0] = '\0';} 
		else succflag = succflag && PL_get_chars(sendert, &sender, gflag); 
	if (lflag) { language[0] = '\0';} 
		else succflag = succflag && PL_get_chars(languaget, &language, gflag); 
	if (rwflag) { rw[0] = '\0';}
		else succflag = succflag && PL_get_chars(rwt, &rw, gflag);
	succflag = succflag && PL_get_chars(irtt, &irt, gflag);
	succflag = succflag && PL_get_chars(contentt, &content, gflag);

	rsc_kqml_say(perf, sender, reciever, language, rw, irt, content);

	if (sflag) succflag = succflag && PL_unify_string_chars(sendert, sender); 
	if (lflag) succflag = succflag && PL_unify_string_chars(languaget, language); 
	if (rwflag) succflag= succflag && PL_unify_string_chars(rwt, rw);

	free(perf);
	free(content);
	free(irt);
	free(language);
	free(reciever);
	free(rw);
	free(sender);


	return (succflag);
}

foreign_t
pl_last_team_in_possession(term_t t_side)
{
        switch (rsc_last_team_in_possession()) {
        case 'l' :
		return PL_unify_atom_chars(t_side, "l");
	case 'r' :
                return PL_unify_atom_chars(t_side, "r");
        default :
                // should never happen
                PL_fail;
        }
}

foreign_t
pl_location_side(term_t t_x, term_t t_y, term_t t_side)
{
        double x, y;
	
	PL_get_float(t_x, &x);
	PL_get_float(t_y, &y);

	if (rsc_location_side(x, y) == FS_Right)
		return PL_unify_atom_chars(t_side, "r");
	else return PL_unify_atom_chars(t_side, "l");
}

foreign_t
pl_log_action(term_t t_level, term_t t_msg)
{
        static char nmsg[1024]; // new message text
        char *msg;
	int level;
        char *pnmsg = nmsg;

	if (!PL_get_integer(t_level, &level)) {
	        PL_warning("%s\n", "log_action/2: You must provide a logging level");
		PL_fail;
	}
	     
        if (!PL_get_chars(t_msg, &msg,  CVT_ALL|BUF_DISCARDABLE)) {
	        PL_warning("%s\n", "log_action/2: I don't know what to log!");
		PL_fail;
	}
	rsc_log_action2(level, msg);
	PL_succeed;
}


foreign_t 
pl_marker_distance(term_t t_marker, term_t t_dist)
{
	MarkerType marker;

	if (!PL_get_marker(t_marker, &marker)) {
		PL_warning("%s\n", "invalid marker");
                PL_fail;
        } 
	return PL_unify_float(t_dist, rsc_marker_distance(marker));
}

foreign_t 
pl_marker_distance_sqr(term_t t_marker, term_t t_dist)
{ 
	MarkerType marker;

	if (!PL_get_marker(t_marker, &marker)) PL_fail;
	return PL_unify_float(t_dist, rsc_marker_distance_sqr(marker));
}

foreign_t 
pl_marker_angle_from_body(term_t t_marker, term_t t_ang)
{
	MarkerType marker;

	if (!PL_get_marker(t_marker, &marker)) PL_fail;
	return PL_unify_float(t_ang, rsc_marker_angle_from_body(marker));
}

foreign_t 
pl_marker_angle_from_neck(term_t t_marker, term_t t_ang)
{
        MarkerType marker;

	if (!PL_get_marker(t_marker, &marker)) PL_fail;
	return PL_unify_float(t_ang, rsc_marker_angle_from_neck(marker));
}
        
foreign_t 
pl_marker_position(term_t t_marker, term_t t_x, term_t t_y)
{
        MarkerType marker;
        float x, y;

	if (!PL_get_marker(t_marker, &marker)) PL_fail;

	rsc_marker_position(marker, &x, &y);

	return PL_unify_float(t_x, x) == 0 ? 0 : PL_unify_float(t_y, y);
}
foreign_t 
pl_marker_x(term_t t_marker, term_t t_x)
{
        MarkerType marker;

	if (!PL_get_marker(t_marker, &marker)) PL_fail;
	return PL_unify_float(t_x, rsc_marker_x(marker));
}
foreign_t 
pl_marker_y(term_t t_marker, term_t t_y)
{
        MarkerType marker;

	if (!PL_get_marker(t_marker, &marker)) PL_fail;
	return PL_unify_float(t_y, rsc_marker_y(marker));
}
foreign_t 
pl_marker_position_valid1(term_t t_marker)
{ 
        MarkerType marker;

	if (!PL_get_marker(t_marker, &marker)) PL_fail;

	if (rsc_marker_position_valid(marker)) PL_succeed;
	PL_fail;
}

// TODO:
// corresponding rsc-function does not exist in robolog.C
foreign_t 
pl_marker_position_valid2(term_t t_marker, term_t t_conf)
{
        // MarkerType marker;
        
	// if (!PL_get_marker(t_marker, &marker)) PL_fail;
        // return PL_unify_float(t_conf, rsc_marker_positon_valid);
        PL_succeed;
}


foreign_t
pl_move(term_t t_x, term_t t_y)
{
        double x, y;

        PL_get_float(t_x, &x);
        PL_get_float(t_y, &y);
        rsc_move(x,y);
        PL_succeed;
}


foreign_t
pl_my_body_ang(term_t t_ang)
{
	return PL_unify_float(t_ang, rsc_my_body_ang());
}


foreign_t
pl_my_conf0()
{
	if (rsc_my_conf()) PL_succeed;
	PL_fail;
}


foreign_t
pl_my_conf1(term_t t_conf)
{
	return PL_unify_float(t_conf, rsc_my_conf());
}


foreign_t
pl_my_dir(term_t t_ang)
{
	return PL_unify_float(t_ang, rsc_my_dir());
}


foreign_t
pl_my_effort(term_t t_effort)
{
        return PL_unify_float(t_effort, rsc_my_effort());
}


foreign_t
pl_my_goal_marker(term_t t_marker)
{
        if (rsc_my_goal_marker() == Goal_L)
                return PL_unify_atom_chars(t_marker, "goal_l");
        else return PL_unify_atom_chars(t_marker, "goal_r");
}


foreign_t
pl_my_location_side(term_t t_side)
{
	if (rsc_my_location_side() == FS_Right)
		return PL_unify_atom_chars(t_side, "r");
	else return PL_unify_atom_chars(t_side, "l");
}


foreign_t
pl_my_neck_global_ang(term_t t_ang)
{
	return PL_unify_float(t_ang, rsc_my_neck_global_ang());
}


foreign_t
pl_my_neck_rel_ang(term_t t_ang)
{
	return PL_unify_float(t_ang, rsc_my_neck_rel_ang());
}


foreign_t
pl_my_number(term_t t_unum)
{
	return PL_unify_integer(t_unum, rsc_my_number());
}


foreign_t
pl_my_offside_line(term_t t_x)
{
        return PL_unify_float(t_x, rsc_my_offside_line());
}


foreign_t
pl_my_pos(term_t t_x, term_t t_y)
{
	float x, y;
        rsc_my_pos(&x, &y);
        
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


foreign_t
pl_my_recovery(term_t t_recovery)
{
        return PL_unify_float(t_recovery, rsc_my_recovery());
}


foreign_t
pl_my_score(term_t t_score)
{
	return PL_unify_integer(t_score, rsc_my_score());
}


foreign_t
pl_my_side(term_t t_side)
{
        if (rsc_my_side() == 'l')
                return PL_unify_atom_chars(t_side, "l");
        else    return PL_unify_atom_chars(t_side, "r");
}


foreign_t
pl_my_speed(term_t t_speed)
{
	return PL_unify_float(t_speed, rsc_my_speed());
}


foreign_t
pl_my_stamina(term_t t_stamina)
{
        return PL_unify_float(t_stamina, rsc_my_stamina());
}


foreign_t
pl_my_team_name(term_t t_name)
{
	return PL_unify_string_chars(t_name, rsc_my_team_name());
}
	

foreign_t
pl_my_team_name_len(term_t t_len)
{
	return PL_unify_integer(t_len, rsc_my_team_name_len());
}


foreign_t
pl_my_vel(term_t t_x, term_t t_y)
{
        float x, y;
        rsc_my_vel(&x, &y);
        
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


foreign_t
pl_my_vel_conf(term_t t_conf)
{
	return PL_unify_float(t_conf, rsc_my_vel_conf());
}


foreign_t
pl_my_view_angle(term_t t_ang)
{
        return PL_unify_float(t_ang, rsc_my_view_angle());
}


foreign_t
pl_my_x(term_t t_x)
{
	return PL_unify_float(t_x, rsc_my_x());
}


foreign_t
pl_my_y(term_t t_y)
{
	return PL_unify_float(t_y, rsc_my_y());
}

// JAN: return the current time
foreign_t
pl_now(term_t t_now)
{
        return PL_unify_integer(t_now, rsc_now());
}

foreign_t
pl_num_opponents_closer_to_ball(term_t t_num)
{
        return PL_unify_integer(t_num, rsc_num_opponents_closer_to_ball());
}

foreign_t
pl_num_opponents_in_cone(term_t t_wd_ratio, term_t t_ex, term_t t_ey,
                         term_t t_x, term_t t_y, term_t t_num)
{
        double wd_ratio;
        double ex,ey;
        double x,y;
        
	if (!PL_get_float(t_wd_ratio, &wd_ratio)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_opponents_in_cone/6" << endl;
                PL_fail;
        }
	if (!PL_get_float(t_ex, &ex)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_opponents_in_cone/6" << endl;
                PL_fail;
        }
	if (!PL_get_float(t_ey, &ey)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_opponents_in_cone/6" << endl;
                PL_fail;
        }
	if (!PL_get_float(t_x, &x)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_opponents_in_cone/6" << endl;
                PL_fail;
        }
	if (!PL_get_float(t_y, &y)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_opponents_in_cone/6" << endl;
                PL_fail;
        }
        return PL_unify_integer(t_num,
                                rsc_num_opponents_in_cone(wd_ratio,ex,ey,x,y));
}

foreign_t
pl_num_opponents_within_2(term_t t_dist, term_t t_num)
{
        double dist;
        
        if (!PL_get_float(t_dist, &dist)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_opponents_within/2" << endl;
                PL_fail;
        }

        return PL_unify_integer(t_num, rsc_num_opponents_within_1(dist));
}

foreign_t
pl_num_opponents_within_4(term_t t_dist, term_t t_x, term_t t_y, term_t t_num)
{
        double dist;
        double x, y;
        
        if (!PL_get_float(t_dist, &dist)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_opponents_within/4" << endl;
                PL_fail;
        }
        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_opponents_within/4" << endl;
                PL_fail;
        }
        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_opponents_within/4" << endl;
                PL_fail;
        }
        return PL_unify_integer(t_num,
                                rsc_num_opponents_within_3(dist, x, y));
}

foreign_t
pl_num_players_within_2(term_t t_dist, term_t t_num)
{
        double dist;
        
        if (!PL_get_float(t_dist, &dist)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_players_within/2" << endl;
                PL_fail;
        }

        return PL_unify_integer(t_num, rsc_num_players_within_1(dist));
}

foreign_t
pl_num_players_within_4(term_t t_dist, term_t t_x, term_t t_y, term_t t_num)
{
        double dist;
        double x, y;
        
        if (!PL_get_float(t_dist, &dist)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_opponents_within/4" << endl;
                PL_fail;
        }
        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_opponents_within/4" << endl;
                PL_fail;
        }
        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_opponents_within/4" << endl;
                PL_fail;
        }
        return PL_unify_integer(t_num,
                                rsc_num_players_within_3(dist, x, y));
}

foreign_t
pl_num_teammates_closer_to_ball(term_t t_num)
{
        return PL_unify_integer(t_num, rsc_num_teammates_closer_to_ball());
}

foreign_t
pl_num_teammates_in_cone(term_t t_wd_ratio, term_t t_ex, term_t t_ey,
                         term_t t_x, term_t t_y, term_t t_num)
{
        double wd_ratio;
        double ex,ey;
        double x,y;
        
	if (!PL_get_float(t_wd_ratio, &wd_ratio)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_teammates_in_cone/6" << endl;
                PL_fail;
        }
	if (!PL_get_float(t_ex, &ex)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_teammates_in_cone/6" << endl;
                PL_fail;
        }
	if (!PL_get_float(t_ey, &ey)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_teammates_in_cone/6" << endl;
                PL_fail;
        }
	if (!PL_get_float(t_x, &x)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_teammates_in_cone/6" << endl;
                PL_fail;
        }
	if (!PL_get_float(t_y, &y)) {
	        cerr << ERR_FLOAT_EXPECTED <<"num_teammates_in_cone/6" << endl;
                PL_fail;
        }
        return PL_unify_integer(t_num,
                                rsc_num_teammates_in_cone(wd_ratio,ex,ey,x,y));
}


foreign_t pl_num_teammates_within_2(term_t t_dist, term_t t_num)
{
        double dist;
        
        if (!PL_get_float(t_dist, &dist)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_teammates_within/2" << endl;
                PL_fail;
        }

        return PL_unify_integer(t_num, rsc_num_teammates_within_1(dist));
}

foreign_t pl_num_teammates_within_4(term_t t_dist, term_t t_x,
                                    term_t t_y, term_t t_num)
{
        double dist;
        double x, y;
        
        if (!PL_get_float(t_dist, &dist)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_teammates_within/4" << endl;
                PL_fail;
        }
        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_teammates_within/4" << endl;
                PL_fail;
        }
        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"num_teammates_within/4" << endl;
                PL_fail;
        }
        return PL_unify_integer(t_num,
                                rsc_num_teammates_within_3(dist, x, y));
}


foreign_t
pl_opponent_in_offside_position(term_t t_unum)
{
        Unum unum;

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"opponent_in_offside_position/1"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
        
        if (rsc_opponent_in_offside_position(unum)) PL_succeed;
        PL_fail;
}


foreign_t
pl_pass_ball(term_t t_teammate, term_t t_target_vel)
{
        Unum teammate;
        double target_vel;

        PL_get_integer(t_teammate, &teammate);
        PL_get_float(t_target_vel, &target_vel);

        rsc_pass_ball(teammate, target_vel);
        PL_succeed;
}


foreign_t
pl_play_mode(term_t t_pm)
{
        switch (rsc_play_mode()) {
        case PM_Before_Kick_Off :
                return PL_unify_atom_chars(t_pm, "before_kick_off");
        case PM_My_Kick_Off :
                return PL_unify_atom_chars(t_pm, "my_kick_off");
        case PM_Their_Kick_Off :
                return PL_unify_atom_chars(t_pm, "their_kick_off");
        case PM_My_Kick_In :
                return PL_unify_atom_chars(t_pm, "my_kick_in");
        case PM_Their_Kick_In :
                return PL_unify_atom_chars(t_pm, "their_kick_in");
        case PM_My_Corner_Kick :
                return PL_unify_atom_chars(t_pm, "my_corner_kick");
        case PM_Their_Corner_Kick :
                return PL_unify_atom_chars(t_pm, "their_corner_kick");
        case PM_My_Goal_Kick :
                return PL_unify_atom_chars(t_pm, "my_goal_kick");
        case PM_Their_Goal_Kick :
                return PL_unify_atom_chars(t_pm, "their_goal_kick");
        case PM_My_Free_Kick :
                return PL_unify_atom_chars(t_pm, "my_free_kick");
        case PM_Their_Free_Kick :
                return PL_unify_atom_chars(t_pm, "their_free_kick");
        case PM_My_Goalie_Free_Kick :     /* not a real play mode */
                return PL_unify_atom_chars(t_pm, "my_goalie_free_kick");
        case PM_Their_Goalie_Free_Kick :  /* not a real play mode */
                return PL_unify_atom_chars(t_pm, "their_goalie_free_kick");
        case PM_Drop_Ball :
                return PL_unify_atom_chars(t_pm, "drop_ball");
        case PM_My_Offside_Kick :
                return PL_unify_atom_chars(t_pm, "my_offside_kick");
        case PM_Their_Offside_Kick :
                return PL_unify_atom_chars(t_pm, "their_offside_kick");
        case PM_Play_On :
                return PL_unify_atom_chars(t_pm, "play_on");
        case PM_Half_Time :
                return PL_unify_atom_chars(t_pm, "half_time");
        case PM_Time_Up :
                return PL_unify_atom_chars(t_pm, "time_up");
        case PM_Extended_Time :
                return PL_unify_atom_chars(t_pm, "extended_time");
        default :
                return PL_unify_atom_chars(t_pm, "no_mode");
        }
}


foreign_t
pl_player_absolute_body_angle(term_t t_side, term_t t_unum, term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_absolute_body_angle/3",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_absolute_body_angle/3"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
	return PL_unify_float(t_ang, rsc_player_absolute_body_angle(s, unum)); 
}


foreign_t
pl_player_absolute_neck_angle(term_t t_side, term_t t_unum, term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_absolute_neck_angle/3",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_absolute_neck_angle/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
	return PL_unify_float(t_ang, rsc_player_absolute_neck_angle(s, unum));
}


foreign_t
pl_player_absolute_position(term_t t_side, term_t t_unum,
                            term_t t_x, term_t t_y)
{
	float x, y;
        char s;
        Unum unum;


        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_absolute_position/4", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
            (unum > rsc_SP_team_size()) || (unum <= 0)) {
                cerr << ERR_UNUM_EXPECTED <<"player_absolute_position/4"
                           << rsc_SP_team_size() << endl;
                PL_fail;
        }

        return PL_unify_position(t_x, t_y, s, unum);
}


foreign_t
pl_player_absolute_velocity(term_t t_side, term_t t_unum, 
			    term_t t_x, term_t t_y)
{
	float x, y;
        char s;
        Unum unum;
        

        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_absolute_velocity/4",1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_absolute_velocity/4"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
        rsc_player_absolute_velocity(s, unum, &x, &y);
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


foreign_t
pl_player_angle_from_body(term_t t_side, term_t t_unum, term_t t_ang)
{
        char s;
        Unum unum;
        

        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_angle_from_body/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_angle_from_body/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
        return PL_unify_float(t_ang, rsc_player_angle_from_body(s, unum));
}


foreign_t
pl_player_angle_from_neck(term_t t_side, term_t t_unum, term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_angle_from_neck/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_angle_from_neck/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
        return PL_unify_float(t_ang, rsc_player_angle_from_neck(s, unum));
}


foreign_t
pl_player_body_angle_valid2(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_body_angle_valid/2", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_body_angle_valid/2"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
	if (rsc_player_body_angle_valid(s, unum)) PL_succeed;
	PL_fail;
}


foreign_t
pl_player_body_angle_valid3(term_t t_side, term_t t_unum, term_t t_conf)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_body_angle_valid/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_body_angle_valid/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
        return PL_unify_float(t_conf, rsc_player_body_angle_valid(s, unum));
}


foreign_t
pl_player_distance(term_t t_side, term_t t_unum, term_t t_dist)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_distance/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_distance/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
        return PL_unify_float(t_dist, rsc_player_distance(s, unum));
}

foreign_t
pl_player_distance_to(term_t t_side, term_t t_unum,
                      term_t t_x, term_t t_y, term_t t_dist)
{
        char s;
        Unum unum;
        double x,y;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_distance_to/5", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_distance_to/5 - 2"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	if (!PL_get_float(t_x, &x)) {
	        cerr << ERR_FLOAT_EXPECTED << "player_distance_to/5 - 3"
                     << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
	        cerr << ERR_FLOAT_EXPECTED << "player_distance_to/5 - 4"
                     << endl;
                PL_fail;
        }        
	
        return PL_unify_float(t_dist, rsc_player_distance_to(s, unum, x, y));
}

foreign_t
pl_player_in_offside_position(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;

        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_in_offside_position/2", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_in_offside_position/2"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
        
        if (rsc_player_in_offside_position(s, unum)) PL_succeed;
        PL_fail;
}

foreign_t
pl_player_interception_cycles(term_t t_side, term_t t_unum, term_t t_power,
                              term_t t_cycles)
{
        char s;
        Unum unum;
        double power;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_interception_cycles/4",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_interception_cycles/4"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

        PL_get_float(t_power, &power);
        
        return PL_unify_integer(t_cycles,
                                rsc_player_interception_cycles(s, unum,
                                                               power));
}


foreign_t
pl_player_interception_cycles_maxp(term_t t_side, term_t t_unum,
                                   term_t t_cycles)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_interception_cycles/3",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_interception_cycles/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

        return PL_unify_integer(t_cycles,
                                rsc_player_interception_cycles_maxp(s, unum));
}


foreign_t
pl_player_interception_dash_power(term_t t_side, term_t t_unum, term_t t_power,
                                  term_t t_dashp)
{
        char s;
        Unum unum;
        double power;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_interception_dash_power/4", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_interception_dash_power/4"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        PL_get_float(t_power, &power);
        
        return PL_unify_float(t_dashp,
                              rsc_player_interception_dash_power(s, unum,
                                                                 power));
}


foreign_t
pl_player_interception_dash_power_maxp(term_t t_side, term_t t_unum,
                                       term_t t_dashp)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_interception_dash_power/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_interception_dash_power/3"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        return PL_unify_float(t_dashp,
                              rsc_player_interception_dash_power_maxp(s,
                                                                      unum));
}


foreign_t
pl_player_interception_point(term_t t_side, term_t t_unum, term_t t_power,
                             term_t t_x, term_t t_y)
{
        char s;
        Unum unum;
        double power;
        float x, y;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_interception_point/5",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_interception_point/5"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        PL_get_float(t_power, &power);
        rsc_player_interception_point(s, unum, power, &x, &y);
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


foreign_t
pl_player_interception_point_maxp(term_t t_side, term_t t_unum,
                                  term_t t_x, term_t t_y)
{
        char s;
        Unum unum;
        float x, y;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_interception_point/4",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_interception_point/4"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        rsc_player_interception_point_maxp(s, unum, &x, &y);
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


foreign_t
pl_player_interception_result(term_t t_side, term_t t_unum, 
			      term_t t_power, term_t t_interc)
{
        char s;
        Unum unum;
	double power; 
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_interception_result/4",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_interception_result/4"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	PL_get_float(t_power, &power); 

	switch (rsc_player_interception_result(s, unum, power)) {
	case BI_None : return PL_unify_atom_chars(t_interc, "none");
	case BI_Invalid : return PL_unify_atom_chars(t_interc, "invalid");
	case BI_Failure : return PL_unify_atom_chars(t_interc, "failure");
	case BI_CanChase : return PL_unify_atom_chars(t_interc, "can_chase");
	case BI_ReadyToKick : return PL_unify_atom_chars(t_interc, "ready");
	}
}


foreign_t
pl_player_interception_result_maxp(term_t t_side, term_t t_unum, 
				   term_t t_interc)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_interception_result/3",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_interception_result/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	switch (rsc_player_interception_result_maxp(s, unum)) {
	case BI_None : return PL_unify_atom_chars(t_interc, "none");
	case BI_Invalid : return PL_unify_atom_chars(t_interc, "invalid");
	case BI_Failure : return PL_unify_atom_chars(t_interc, "failure");
	case BI_CanChase : return PL_unify_atom_chars(t_interc, "can_chase");
	case BI_ReadyToKick : return PL_unify_atom_chars(t_interc, "ready");
	}
}


foreign_t
pl_player_interceptionable(term_t t_side, term_t t_unum, term_t t_power)
{
        char s;
        Unum unum;
        double power;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_interceptionable/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_interceptionable/3"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        PL_get_float(t_power, &power);
        
        if (rsc_player_interceptionable(s, unum, power)) PL_succeed;
        PL_fail;
}


foreign_t
pl_player_interceptionable_maxp(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_interceptionable/2", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_interceptionable/2"
                           << rsc_SP_team_size() << endl;
                PL_fail;
	}

        if (rsc_player_interceptionable_maxp(s, unum)) PL_succeed;
        PL_fail;
}


foreign_t
pl_player_neck_angle_valid2(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_neck_angle_valid/2",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_neck_angle_valid/2"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	if (rsc_player_neck_angle_valid(s, unum)) PL_succeed;
	PL_fail;
}


foreign_t
pl_player_neck_angle_valid3(term_t t_side, term_t t_unum, term_t t_conf)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_neck_angle_valid/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_neck_angle_valid/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	return PL_unify_float(t_conf, rsc_player_neck_angle_valid(s, unum));
}


foreign_t
pl_player_position_valid2(term_t t_side, term_t t_unum, control_t ctrl)
{
        // JAN: inserted type casts for every call to malloc (total of 4)
        char s;
        Unum unum;

        player_context *p;

        if (PL_get_integer(t_unum, &unum)) {
                if (!PL_get_side(t_side, &s)) {
                        PL_warning(ERR_SIDE_EXPECTED,
                                   "player_position_valid/2", 1);
                        PL_fail;
                }
                
                if ((unum > rsc_SP_team_size()) || (unum <= 0)) {
                        cerr << ERR_UNUM_EXPECTED
                             << "player_position_valid/2 "
                             << rsc_SP_team_size() << endl;
                        PL_fail;
                } else {
                        if (rsc_player_position_valid(s, unum))
                                PL_succeed;
                        PL_fail;
                }
        }

        if (PL_is_variable(t_unum)) {
                switch(PL_foreign_control(ctrl)) {
                case PL_FIRST_CALL:
                        p = (player_context *)malloc(sizeof(player_context_t));
                        
                        if (!PL_get_side(t_side, &(p->s))) {
                                PL_warning(ERR_SIDE_EXPECTED,
                                           "player_position_valid/2", 1);
                                PL_fail;
                        }
                        p->n = 1;
                        break;
                case PL_REDO:
                        p = (player_context *)PL_foreign_context_address(ctrl);
                        break;                        
                case PL_CUTTED:
                        free(p);
                        PL_succeed;
                }
                
                while ((p->n <= rsc_SP_team_size()) &&
                       (!rsc_player_position_valid(p->s, p->n)))
                        p->n++;

                if (p->n <= rsc_SP_team_size()) {
                        PL_unify_integer(t_unum, p->n);
                        p->n++;
                        PL_retry_address(p);
                }
                
                PL_fail;
        }

        PL_fail;

}


foreign_t
pl_player_position_valid3(term_t t_side,
                          term_t t_unum,
                          term_t t_conf,
                          control_t ctrl)
{
        char s;
        Unum unum;

        player_context *p;

        if (PL_get_integer(t_unum, &unum)) {
                if (!PL_get_side(t_side, &s)) {
                        PL_warning(ERR_SIDE_EXPECTED,
                                   "player_position_valid/3", 1);
                        PL_fail;
                }
                
                if ((unum > rsc_SP_team_size()) || (unum <= 0)) {
                        cerr << ERR_UNUM_EXPECTED <<
                                   "player_position_valid/3"
                                   << rsc_SP_team_size() << endl;
                        PL_fail;
                } else {
                        PL_unify_float(t_conf,
                                       rsc_player_position_valid(s, unum));
                }
        }

        if (PL_is_variable(t_unum)) {
                switch(PL_foreign_control(ctrl)) {
                case PL_FIRST_CALL:
                        p = (player_context *)malloc(sizeof(player_context_t));
                        
                        if (!PL_get_side(t_side, &(p->s))) {
                                PL_warning(ERR_SIDE_EXPECTED,
                                           "player_position_valid/3", 1);
                                PL_fail;
                        }
                        p->n = 1;
                        break;
                case PL_REDO:
                        p =  (player_context *)PL_foreign_context_address(ctrl);
                        break;                        
                case PL_CUTTED:
                        free(p);
                        PL_succeed;
                }

//                while ((p->n <= rsc_SP_team_size()) &&
//                       (!rsc_player_position_valid(p->s, p->n)))
//                        p->n++;

                if (p->n <= rsc_SP_team_size()) {
                        PL_unify_integer(t_unum, p->n);
                        PL_unify_float(t_conf,
                                       rsc_player_position_valid(p->s,
                                                                 p->n));
                        p->n++;
                        PL_retry_address(p);
                }
                
                PL_fail;
        }

        PL_fail;

}


foreign_t
pl_player_relative_neck_angle(term_t t_side, term_t t_unum, term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_relative_neck_angle/3",
                           1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_relative_neck_angle/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	return PL_unify_float(t_ang, rsc_player_relative_neck_angle(s, unum));
}


foreign_t
pl_player_relative_to_body_body_angle(term_t t_side, term_t t_unum, 
				      term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_body_body_angle/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_body_body_angle/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	return PL_unify_float(t_ang, 
			      rsc_player_relative_to_body_body_angle(s, unum));
}


foreign_t
pl_player_relative_to_body_neck_angle(term_t t_side, term_t t_unum, 
				      term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_body_neck_angle/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_body_neck_angle/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	return PL_unify_float(t_ang, 
			      rsc_player_relative_to_body_neck_angle(s, unum));
}


foreign_t
pl_player_relative_to_body_heading(term_t t_side, term_t t_unum, 
                                   term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_body_heading/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_body_heading/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	return PL_unify_float(t_ang, 
			      rsc_player_relative_to_body_heading(s, unum));
}


foreign_t
pl_player_relative_to_body_position(term_t t_side, term_t t_unum, 
				    term_t t_x, term_t t_y)
{
        char s;
        Unum unum;
	float x, y;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_body_position/4", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_body_position/4"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	rsc_player_relative_to_body_position(s, unum, &x, &y);
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}

 	
foreign_t
pl_player_relative_to_body_velocity(term_t t_side, term_t t_unum, 
				    term_t t_x, term_t t_y)
{
        char s;
        Unum unum;
	float x, y;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_body_velocity/4", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_body_velocity/4"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	rsc_player_relative_to_body_velocity(s, unum, &x, &y);
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


foreign_t
pl_player_relative_to_neck_body_angle(term_t t_side, term_t t_unum, 
				      term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_neck_body_angle/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_neck_body_angle/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	return PL_unify_float(t_ang, 
			      rsc_player_relative_to_neck_body_angle(s, unum));
}


foreign_t
pl_player_relative_to_neck_neck_angle(term_t t_side, term_t t_unum, 
				      term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_neck_neck_angle/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_neck_neck_angle/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	return PL_unify_float(t_ang, 
			      rsc_player_relative_to_neck_neck_angle(s, unum));
}

#if 0
// rsc_player_relative_to_neck_heading gibt es noch nicht
foreign_t
pl_player_relative_to_neck_heading(term_t t_side, term_t t_unum, 
				      term_t t_ang)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_neck_heading/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_neck_heading/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	return PL_unify_float(t_ang, 
			      rsc_player_relative_to_neck_heading(s, unum));
}
#endif


foreign_t
pl_player_relative_to_neck_position(term_t t_side, term_t t_unum, 
				    term_t t_x, term_t t_y)
{
        char s;
        Unum unum;
	float x, y;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_neck_position/4", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_neck_position/4"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	rsc_player_relative_to_neck_position(s, unum, &x, &y);
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}

 	
foreign_t
pl_player_relative_to_neck_velocity(term_t t_side, term_t t_unum, 
				    term_t t_x, term_t t_y)
{
        char s;
        Unum unum;
	float x, y;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED,
                           "player_relative_to_neck_velocity/4", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<
                           "player_relative_to_neck_velocity/4"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	rsc_player_relative_to_neck_velocity(s, unum, &x, &y);
        return PL_unify_float(t_x,x) == 0 ? 0 : PL_unify_float(t_y,y);
}


foreign_t
pl_player_speed(term_t t_side, term_t t_unum, term_t t_speed)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_speed/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_speed/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}

	return PL_unify_float(t_speed, rsc_player_speed(s, unum));
}


foreign_t
pl_player_velocity_valid2(term_t t_side, term_t t_unum)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_velocity_valid/2", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_velocity_valid/2"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
	if (rsc_player_velocity_valid(s, unum)) PL_succeed;
	PL_fail;
}


foreign_t
pl_player_velocity_valid3(term_t t_side, term_t t_unum, term_t t_conf)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_velocity_valid/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_velocity_valid/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
        return PL_unify_float(t_conf, rsc_player_velocity_valid(s, unum));
}


foreign_t
pl_player_x(term_t t_side, term_t t_unum, term_t t_x)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_x/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_x/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
        
        return PL_unify_float(t_x, rsc_player_x(s, unum));
}

foreign_t
pl_player_y(term_t t_side, term_t t_unum, term_t t_y)
{
        char s;
        Unum unum;
        
        if (!PL_get_side(t_side, &s)) {
	        PL_warning(ERR_SIDE_EXPECTED, "player_y/3", 1);
                PL_fail;
        }

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"player_y/3"
			   << rsc_SP_team_size() << endl;
                PL_fail;
	}
	
        return PL_unify_float(t_y, rsc_player_y(s, unum));
}

foreign_t
pl_ray_circle_intersect_7(term_t t_x1, term_t t_y1,  term_t t_x2, term_t t_y2,
                          term_t t_x3, term_t t_y3, term_t t_rad) 
{
        double x1,y1;
        double x2,y2;
        double x3,y3;
        double radius;
        
        if (!PL_get_float(t_x1, &x1)) {
                cerr << ERR_FLOAT_EXPECTED << "ray_circle_intersect/7 - 1"
                     << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y1, &y1)) {
                cerr << ERR_FLOAT_EXPECTED << "ray_circle_intersect/7 - 2"
                     << endl;
                PL_fail;
        }

        if (!PL_get_float(t_x2, &x2)) {
                cerr << ERR_FLOAT_EXPECTED << "ray_circle_intersect/7 - 3"
                     << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y2, &y2)) {
                cerr << ERR_FLOAT_EXPECTED << "ray_circle_intersect/7 - 4"
                     << endl;
                PL_fail;
        }
        
        if (!PL_get_float(t_x3, &x3)) {
                cerr << ERR_FLOAT_EXPECTED << "ray_circle_intersect/7 - 5"
                     << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y3, &y3)) {
                cerr << ERR_FLOAT_EXPECTED << "ray_circle_intersect/7 - 6"
                     << endl;
                PL_fail;
        }
        
        if (!PL_get_float(t_rad, &radius)) {
                cerr << ERR_FLOAT_EXPECTED << "ray_circle_intersect/7 - 6"
                     << endl;
                PL_fail;
        }

        if (rsc_ray_circle_intersect_7(x1,y1,x2,y2,x3,y3,radius) > 0)
                PL_succeed;
        PL_fail;
}

foreign_t
pl_say(term_t t_msg)
{
        static char nmsg[1024]; // new message text
        char *msg;
        char *pnmsg = nmsg;

        if (PL_get_chars(t_msg, &msg,  CVT_ALL|BUF_DISCARDABLE)) {
                /* moddy: work here */
                /* hear: look at ../robolog/parse.C */
                
	 	rsc_encode(pnmsg, msg,"RoBoLoG", 1024);
                rsc_say(rsc_crcsum(pnmsg));
                PL_succeed;
        } else {
                PL_warning("%s\n", "say/1: say what? (use atoms or chars)");
                PL_fail;
        }
}


foreign_t
pl_scan_field_with_body()
{
        if (rsc_scan_field_with_body()  == AQ_ActionQueued) PL_succeed;
        PL_fail;
}


foreign_t
pl_scan_field_with_neck()
{
        rsc_scan_field_with_neck();
        PL_succeed;
}

foreign_t
pl_smart_dribble_to_3(term_t t_x, term_t t_y, term_t t_drib_res)
{
        double x,y;
        
        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED << "smart_dribble_to/3"  << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED << "smart_dribble_to/3" << endl;
                PL_fail;
        }

        return PL_unify_dribble_res(t_drib_res, rsc_smart_dribble_to_2(x,y));
}

foreign_t
pl_smart_dribble_to_4(term_t t_x, term_t t_y,
                      term_t t_dash_pow, term_t t_drib_res)
{
        double x,y;
        double dash_pow;
        
        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED << "smart_dribble_to/3"  << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED << "smart_dribble_to/3" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_dash_pow, &dash_pow)) {
                cerr << ERR_FLOAT_EXPECTED << "smart_dribble_to/3" << endl;
                PL_fail;
        }
        
        return PL_unify_dribble_res(t_drib_res,
                                    rsc_smart_dribble_to_3(x,y, dash_pow));
}

foreign_t
pl_smart_kick_hard_2(term_t t_dir, term_t t_mode)
{
        double dir;
        KickMode mode;
        
        if (!PL_get_float(t_dir, &dir)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_kick_hard/2" << endl;
                PL_fail;
        }

        if (!PL_get_kick_mode(t_mode, &mode)) {
                PL_warning(ERR_KICKMODE_EXPECTED, "smart_kick_hard/2", 2);
                PL_fail;
        }
        if (rsc_smart_kick_hard_2(dir, mode)) PL_succeed;
        PL_fail;
}

foreign_t
pl_smart_kick_hard_3(term_t t_dir, term_t t_mode, term_t t_ro_vel)
{
        double dir;
        KickMode mode;
        TurnDir rot;
        double targ_vel;
        
        if (!PL_get_float(t_dir, &dir)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_kick_hard/3" << endl;
                PL_fail;
        }

        if (!PL_get_kick_mode(t_mode, &mode)) {
                PL_warning(ERR_KICKMODE_EXPECTED, "smart_kick_hard/3", 2);
                PL_fail;
        }

        if (!PL_get_turn_dir(t_ro_vel, &rot)) {
                if (!PL_get_float(t_ro_vel, &targ_vel)) {
                        PL_warning(ERR_TURN_DIR_OR_FLOAT_EXPECTED,
                                   "smart_kick_hard/3", 3);
                        PL_fail;
                }
                if (rsc_smart_kick_hard_3(dir, mode, targ_vel)) PL_succeed;
                PL_fail;
        } else {
                if (rsc_smart_kick_hard_rot_3(dir, mode, rot)) PL_succeed;
                PL_fail;
        }
}


foreign_t
pl_smart_kick_hard_4(term_t t_dir, term_t t_mode,
                     term_t t_targ_vel, term_t t_rot)
{
        double dir;
        KickMode mode;
        TurnDir rot;
        double targ_vel;
        
        if (!PL_get_float(t_dir, &dir)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_kick_hard/4" << endl;
                PL_fail;
        }

        if (!PL_get_kick_mode(t_mode, &mode)) {
                PL_warning(ERR_KICKMODE_EXPECTED, "smart_kick_hard/4", 2);
                PL_fail;
        }

        if (!PL_get_float(t_targ_vel, &targ_vel)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_kick_hard/4" << endl;
                PL_fail;
        }

        if (!PL_get_turn_dir(t_rot, &rot)) {
                PL_warning(ERR_TURN_DIR_EXPECTED, "smart_kick_hard/4", 4);
                PL_fail;
        }
        
        if (rsc_smart_kick_hard_rot_4(dir, mode, targ_vel, rot)) PL_succeed;
        PL_fail;
}

// smart_kick_hard_abs functions start here
foreign_t
pl_smart_kick_hard_abs_2(term_t t_dir, term_t t_mode)
{
        double dir;
        KickMode mode;
        
        if (!PL_get_float(t_dir, &dir)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_kick_hard_abs/2" << endl;
                PL_fail;
        }

        if (!PL_get_kick_mode(t_mode, &mode)) {
                PL_warning(ERR_KICKMODE_EXPECTED, "smart_kick_hard_abs/2", 2);
                PL_fail;
        }
        if (rsc_smart_kick_hard_abs_2(dir, mode)) PL_succeed;
        PL_fail;
}

foreign_t
pl_smart_kick_hard_abs_3(term_t t_dir, term_t t_mode, term_t t_ro_vel)
{
        double dir;
        KickMode mode;
        TurnDir rot;
        double targ_vel;
        
        if (!PL_get_float(t_dir, &dir)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_kick_hard_abs/3" << endl;
                PL_fail;
        }

        if (!PL_get_kick_mode(t_mode, &mode)) {
                PL_warning(ERR_KICKMODE_EXPECTED, "smart_kick_hard_abs/3", 2);
                PL_fail;
        }

        if (!PL_get_turn_dir(t_ro_vel, &rot)) {
                if (!PL_get_float(t_ro_vel, &targ_vel)) {
                        PL_warning(ERR_TURN_DIR_OR_FLOAT_EXPECTED,
                                   "smart_kick_hard_abs/3", 3);
                        PL_fail;
                }
                if (rsc_smart_kick_hard_abs_3(dir, mode, targ_vel)) PL_succeed;
                PL_fail;
        } else {
                if (rsc_smart_kick_hard_rot_abs_3(dir, mode, rot)) PL_succeed;
                PL_fail;
        }
}


foreign_t
pl_smart_kick_hard_abs_4(term_t t_dir, term_t t_mode,
                     term_t t_targ_vel, term_t t_rot)
{
        double dir;
        KickMode mode;
        TurnDir rot;
        double targ_vel;
        
        if (!PL_get_float(t_dir, &dir)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_kick_hard_abs/4" << endl;
                PL_fail;
        }

        if (!PL_get_kick_mode(t_mode, &mode)) {
                PL_warning(ERR_KICKMODE_EXPECTED, "smart_kick_hard_abs/4", 2);
                PL_fail;
        }

        if (!PL_get_float(t_targ_vel, &targ_vel)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_kick_hard_abs/4" << endl;
                PL_fail;
        }

        if (!PL_get_turn_dir(t_rot, &rot)) {
                PL_warning(ERR_TURN_DIR_EXPECTED, "smart_kick_hard_abs/4", 4);
                PL_fail;
        }
        cerr << "ROT: " << rot << endl;        
        if (rsc_smart_kick_hard_rot_abs_4(dir, mode, targ_vel, rot)) PL_succeed;
        PL_fail;
}


foreign_t
pl_smart_pass_2(term_t t_x, term_t t_y)
{
        double x, y;

        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/2"  << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/2" << endl;
                PL_fail;
        }

        if (rsc_smart_pass_2(x,y)) PL_succeed;
        PL_fail;
}

foreign_t
pl_smart_pass_3(term_t t_x, term_t t_y, term_t t_targ_vel)
{
        double x, y;
        double targ_vel;

        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/3" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/3" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_targ_vel, &targ_vel)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/3" << endl;
                PL_fail;
        }

        if (rsc_smart_pass_3(x,y,targ_vel)) PL_succeed;
        PL_fail;
}

foreign_t
pl_smart_pass_4(term_t t_x, term_t t_y, term_t t_targ_vel, term_t t_mode)
{
        double x, y;
        double targ_vel;
        KickMode mode;

        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/4" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/4" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_targ_vel, &targ_vel)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/4" << endl;
                PL_fail;
        }

        if (!PL_get_kick_mode(t_mode, &mode)) {
                PL_warning(ERR_KICKMODE_EXPECTED, "smart_pass/4", 4);
                PL_fail;
        }

        if (rsc_smart_pass_4(x,y,targ_vel,mode)) PL_succeed;
        PL_fail;
}

foreign_t
pl_smart_pass_5(term_t t_x, term_t t_y, term_t t_targ_vel,
                term_t t_mode, term_t t_rot)
{
        double x, y;
        double targ_vel;
        KickMode mode;
        TurnDir rot;

        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/5" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/5" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_targ_vel, &targ_vel)) {
                cerr << ERR_FLOAT_EXPECTED <<"smart_pass/5" << endl;
                PL_fail;
        }

        if (!PL_get_kick_mode(t_mode, &mode)) {
                PL_warning(ERR_KICKMODE_EXPECTED, "smart_pass/5", 4);
                PL_fail;
        }

        if (!PL_get_turn_dir(t_rot, &rot)) {
                PL_warning(ERR_KICKMODE_EXPECTED, "smart_pass/5", 5);
                PL_fail;
        }

        if (rsc_smart_pass_5(x,y,targ_vel,mode,rot)) PL_succeed;
        PL_fail;
}


foreign_t
pl_stop_ball()
{
        rsc_stop_ball();
	PL_succeed;
}


foreign_t
pl_team_in_possession_1(term_t t_side)
{
        switch (rsc_team_in_possession(0.0)) {
        case 'l' :
		return PL_unify_atom_chars(t_side, "l");
	case 'r' :
                return PL_unify_atom_chars(t_side, "r");
        default :
                PL_fail;
        }
}

foreign_t
pl_team_with_ball(term_t t_side)
{
        switch (rsc_team_with_ball(0.0)) {
        case 'l' :
		return PL_unify_atom_chars(t_side, "l");
	case 'r' :
                return PL_unify_atom_chars(t_side, "r");
        default :
                PL_fail;
        }
}

foreign_t
pl_teammate_in_offside_position(term_t t_unum)
{
        Unum unum;

        if (!PL_get_integer(t_unum, &unum) ||
	    (unum > rsc_SP_team_size()) ||
	    (unum <= 0)) {
	        cerr << ERR_UNUM_EXPECTED <<"teammate_in_offside_position/1"
                     << rsc_SP_team_size() << endl;
                PL_fail;
	}
        
        if (rsc_teammate_in_offside_position(unum)) PL_succeed;
        PL_fail;
}


foreign_t
pl_their_goal_marker(term_t t_marker)
{
        if (rsc_their_goal_marker() == Goal_L)
                return PL_unify_atom_chars(t_marker, "goal_l");
        else return PL_unify_atom_chars(t_marker, "goal_r");
}


foreign_t
pl_their_offside_line(term_t t_x)
{
        return PL_unify_float(t_x, rsc_their_offside_line());
}


foreign_t
pl_their_score(term_t t_score)
{
	return PL_unify_integer(t_score, rsc_their_score());
}


foreign_t
pl_their_side(term_t t_side)
{
	if (rsc_their_side() == 'l') 
		return PL_unify_atom_chars(t_side, "l");
	return PL_unify_atom_chars(t_side, "r");
}


foreign_t
pl_their_team_name(term_t t_name)
{
	return PL_unify_string_chars(t_name, rsc_their_team_name());
}

foreign_t
pl_tired()
{
        if (rsc_tired()) PL_succeed;
        PL_fail;
}


foreign_t
pl_turn(term_t t_ang)
{
        double ang;

        PL_get_float(t_ang, &ang);
        rsc_turn(ang);
        PL_succeed;
}


foreign_t
pl_turn_neck(term_t t_ang)
{
        double ang;

        PL_get_float(t_ang, &ang);
        rsc_turn_neck(ang);
        PL_succeed;
}


foreign_t
pl_test_go_to_ball()
{
        rsc_test_go_to_ball();
        PL_succeed;
}


foreign_t
pl_test_go_to_point(term_t t_x, term_t t_y, term_t t_buffer, term_t t_power)
{
        double x, y;
        double buffer;
        double power;
        
        PL_get_float(t_x, &x);
        PL_get_float(t_y, &y);
        PL_get_float(t_buffer, &buffer);
        PL_get_float(t_power, &power);

        rsc_test_go_to_point(x, y, buffer, power);
        PL_succeed;
}


foreign_t
pl_test_kick()
{
        rsc_test_kick();
        PL_succeed;
}

foreign_t
pl_test_kick_2()
{
        rsc_test_kick_2();
        PL_succeed;
}

foreign_t
pl_test_random_movement()
{
        rsc_test_random_movement();
        PL_succeed;        
}

foreign_t
pl_vel_at_pt_2_vel_at_foot(term_t t_x, term_t t_y,
                           term_t t_v_target, term_t t_v_start)
{
        double x, y;
        double v_target;
        
        if (!PL_get_float(t_x, &x)) {
                cerr << ERR_FLOAT_EXPECTED
                     << "vel_at_pt_2_vel_at_foot/4 - 1" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_y, &y)) {
                cerr << ERR_FLOAT_EXPECTED
                     << "vel_at_pt_2_vel_at_foot/4 - 2" << endl;
                PL_fail;
        }

        if (!PL_get_float(t_v_target, &v_target)) {
                cerr << ERR_FLOAT_EXPECTED
                     << "vel_at_pt_2_vel_at_foot/4 - 3" << endl;
                PL_fail;
        }

        return PL_unify_float(t_v_start,
                              rsc_vel_at_pt_2_vel_at_foot(x,y,v_target));
}

#ifdef __cplusplus
}
#endif
