/* -*- Mode: C++ -*-
   
   this file is part of the robolog libraries
   Copyright (C) Dec 27 1999 Oliver Obst
   main file for the robolog swi-prolog library
   $Id: swi-robolog.h,v 2.13 2000/08/22 14:03:25 fruit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _SWI_ROBOLOG_H_
#define _SWI_ROBOLOG_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <SWI-Prolog.h>
#include <robolog.h>

void prolog_behave();
void install_marker_atoms();
void install_kick_mode_atoms();
void install_turn_dir_atoms();

bool PL_get_marker(term_t t_marker, MarkerType *m); 

#ifdef __cplusplus
extern "C" {
# if 0 // only to switch of stupid xemacs indenting
}
# endif
#endif
foreign_t pl_angle_to_from_body(term_t t_x, term_t t_y, term_t t_angle);
foreign_t pl_angle_to_from_neck(term_t t_x, term_t t_y, term_t t_angle);
foreign_t pl_announce_positions();
foreign_t pl_at_pos_2(term_t t_x, term_t t_y);
foreign_t pl_at_pos_3(term_t t_x, term_t t_y, term_t t_buf);
foreign_t pl_at_pos_5(term_t t_x0, term_t t_y0,
                      term_t t_x1, term_t t_y1, term_t t_buf);
foreign_t pl_ball_absolute_heading(term_t t_ang);
foreign_t pl_ball_absolute_position(term_t t_x, term_t t_y);
foreign_t pl_ball_absolute_velocity(term_t t_x, term_t t_y);
foreign_t pl_ball_angle_from_body(term_t t_ang);
foreign_t pl_ball_angle_from_neck(term_t t_ang);
foreign_t pl_ball_catchable();
foreign_t pl_ball_distance(term_t t_dist);
foreign_t pl_ball_kick_rate(term_t t_rate);
foreign_t pl_ball_kickable();
foreign_t pl_ball_kickable_for_player(term_t t_side, term_t t_unum, 
				      term_t t_buffer);
foreign_t pl_ball_moving();

foreign_t pl_ball_path_intercept_am_i_there();
foreign_t pl_ball_path_intercept_am_i_there_1(term_t t_buffer);
foreign_t pl_ball_path_intercept_can_i_get_there();
foreign_t pl_ball_path_intercept_can_i_get_there_1(term_t t_power);
foreign_t pl_ball_path_intercept_cycles_for_ball(term_t t_cycles);
foreign_t pl_ball_path_intercept_distance(term_t t_dist);
foreign_t pl_ball_path_intercept_point(term_t t_x, term_t t_y);
foreign_t pl_ball_path_intercept_valid();

foreign_t pl_ball_position_valid0();
foreign_t pl_ball_position_valid1(term_t t_conf);
foreign_t pl_ball_possessor_1(term_t t_unum);
foreign_t pl_ball_possessor_2(term_t t_unum, term_t t_team);

foreign_t pl_ball_relative_to_body_heading(term_t t_ang);
foreign_t pl_ball_relative_to_body_position(term_t t_x, term_t t_y);
foreign_t pl_ball_relative_to_body_velocity(term_t t_x, term_t t_y);
foreign_t pl_ball_relative_to_neck_heading(term_t t_ang);
foreign_t pl_ball_relative_to_neck_position(term_t t_x, term_t t_y);
foreign_t pl_ball_relative_to_neck_velocity(term_t t_x, term_t t_y);
foreign_t pl_ball_speed(term_t t_speed);
foreign_t pl_ball_velocity_valid0();
foreign_t pl_ball_velocity_valid1(term_t t_conf);
foreign_t pl_ball_x(term_t t_x);
foreign_t pl_ball_y(term_t t_y);
foreign_t pl_best_kick_mode(term_t t_ang, term_t t_kick_mode);
foreign_t pl_best_kick_mode_abs(term_t t_ang, term_t t_kick_mode);
foreign_t pl_can_face_ball_with_neck();
foreign_t pl_can_see_ball_with_neck();
foreign_t pl_change_view(term_t t_qual, term_t t_width);
// JAN
foreign_t pl_closest_opponent_to_ball(term_t t_unum);
foreign_t pl_closest_teammate_to_ball(term_t t_who, term_t t_unum);
foreign_t pl_dash(term_t t_power);
foreign_t pl_direction_quality(term_t t_ang, term_t t_sect, term_t t_qual);
foreign_t pl_disconnect();
foreign_t pl_distance_to(term_t t_x, term_t t_y, term_t t_dist);
foreign_t pl_dribble_to_4(term_t t_x, term_t t_y,
                          term_t t_drib_ang, term_t t_drib_res);
foreign_t pl_estimated_cycles_to_steal_2(term_t t_unum, term_t t_cycles);
foreign_t pl_fastest_teammate_to_ball();
foreign_t pl_fastest_opponent_to_ball();
foreign_t pl_face_neck_and_body_to_ball();
foreign_t pl_face_neck_to_ball();
foreign_t pl_face_only_body_to_ball();
foreign_t pl_face_only_neck_to_ball();
foreign_t pl_face_neck_and_body_to_player(term_t t_side, term_t t_unum);
foreign_t pl_face_neck_to_player(term_t t_side, term_t t_unum);
foreign_t pl_face_only_body_to_player(term_t t_side, term_t t_unum);
foreign_t pl_face_only_neck_to_player(term_t t_side, term_t t_unum);
foreign_t pl_get_ball();
foreign_t pl_get_ball_1(term_t t_force);
foreign_t pl_get_his_name(term_t t_His_Number, term_t t_His_name);
foreign_t pl_get_my_name(term_t t_My_name);
foreign_t pl_go_to_point(term_t t_x, term_t t_y, term_t t_buffer,   
			 term_t t_power, term_t t_dodge);
foreign_t pl_go_to_static_ball(term_t t_ang);
foreign_t pl_goalie_catch(term_t t_ang);
foreign_t pl_goalie_number(term_t t_unum);
foreign_t pl_goalie_number_2(term_t t_side, term_t t_unum);
foreign_t pl_hear(term_t t_msg);
foreign_t pl_hold_ball();
foreign_t pl_in_offside_position();
foreign_t pl_is_opponent_behind_2(term_t t_unum, term_t t_ang);
foreign_t pl_is_opponent_behind_3(term_t t_unum, term_t t_x, term_t t_y);
foreign_t pl_is_opponent_behind_from_body(term_t t_unum);
foreign_t pl_is_opponent_behind_from_neck(term_t t_unum);
foreign_t pl_is_player_behind_3(term_t t_side, term_t t_unum, term_t t_ang);
foreign_t pl_is_player_behind_4(term_t t_side, term_t t_unum,
                                term_t t_x, term_t t_y);
foreign_t pl_is_player_behind_from_body(term_t t_side, term_t t_unum);
foreign_t pl_is_player_behind_from_neck(term_t t_side, term_t t_unum);
foreign_t pl_is_point_behind_3(term_t t_x0, term_t t_y0, term_t t_ang);
foreign_t pl_is_point_behind_4(term_t t_x0, term_t t_y0,
                               term_t t_x1, term_t t_y1);
foreign_t pl_is_point_behind_body(term_t t_x0, term_t t_y0);
foreign_t pl_is_point_behind_neck(term_t t_x0, term_t t_y0);
foreign_t pl_is_straight_kick(term_t t_dir, term_t t_dist, term_t t_buffer);
foreign_t pl_is_teammate_behind_2(term_t t_unum, term_t t_ang, control_t ctrl);
foreign_t pl_is_teammate_behind_3(term_t t_unum, term_t t_x, term_t t_y);
foreign_t pl_is_teammate_behind_from_body(term_t t_unum);
foreign_t pl_is_teammate_behind_from_neck(term_t t_unum);
foreign_t pl_kick(term_t t_power, term_t t_dir);
foreign_t pl_kick_ball(term_t t_x, term_t t_y, term_t t_mode, term_t t_rot);
foreign_t pl_kick_in_progress();
foreign_t pl_kqml_hear(term_t perft, term_t sendert, term_t recievert, term_t languaget, term_t rwt, term_t irtt, term_t contentt);
foreign_t pl_kqml_say (term_t perft, term_t sendert, term_t recievert, term_t languaget, term_t rwt, term_t irtt, term_t contentt);
foreign_t pl_last_team_in_possession(term_t t_side);
//JAN
foreign_t pl_log_action(term_t t_level, term_t t_msg);
foreign_t pl_location_side(term_t t_x, term_t t_y, term_t t_side);
foreign_t pl_marker_distance(term_t t_marker, term_t t_dist);
foreign_t pl_marker_distance_sqr(term_t t_marker, term_t t_dist);
foreign_t pl_marker_angle_from_body(term_t t_marker, term_t t_ang);
foreign_t pl_marker_angle_from_neck(term_t t_marker, term_t t_ang);
foreign_t pl_marker_position(term_t t_marker, term_t t_x, term_t t_y);
foreign_t pl_marker_x(term_t t_marker, term_t t_x);
foreign_t pl_marker_y(term_t t_marker, term_t t_y);
foreign_t pl_marker_position_valid1(term_t t_marker);
foreign_t pl_marker_position_valid2(term_t t_marker, term_t t_conf);
foreign_t pl_move(term_t t_x, term_t t_y);
foreign_t pl_my_body_ang(term_t t_ang);
foreign_t pl_my_conf0();
foreign_t pl_my_conf1(term_t t_conf);
foreign_t pl_my_dir(term_t t_ang);
foreign_t pl_my_effort(term_t t_effort);
foreign_t pl_my_goal_marker(term_t t_marker);
foreign_t pl_my_location_side(term_t t_side);
foreign_t pl_my_neck_global_ang(term_t t_ang);
foreign_t pl_my_neck_rel_ang(term_t t_ang);
foreign_t pl_my_number(term_t t_unum);
foreign_t pl_my_offside_line(term_t t_x);
foreign_t pl_my_pos(term_t t_x, term_t t_y);
foreign_t pl_my_recovery(term_t t_recovery);
foreign_t pl_my_score(term_t t_score);
foreign_t pl_my_side(term_t t_side);
foreign_t pl_my_speed(term_t t_speed);
foreign_t pl_my_stamina(term_t t_stamina);
foreign_t pl_my_team_name(term_t t_name);
foreign_t pl_my_team_name_len(term_t t_len);
foreign_t pl_my_team_with_ball(void);
foreign_t pl_my_team_with_ball(void);
foreign_t pl_my_vel(term_t t_x, term_t t_y);
foreign_t pl_my_vel_conf(term_t t_conf);
foreign_t pl_my_view_angle(term_t t_ang);
foreign_t pl_my_x(term_t t_x);
foreign_t pl_my_y(term_t t_y);
foreign_t pl_now(term_t t_now);
foreign_t pl_num_opponents_closer_to_ball(term_t t_num);
foreign_t pl_num_opponents_in_cone(term_t t_wd_ratio, term_t t_ex, term_t t_ey,
                                   term_t t_x, term_t t_y, term_t t_num);
foreign_t pl_num_opponents_within_2(term_t t_dist, term_t t_num);
foreign_t pl_num_opponents_within_4(term_t t_dist, term_t t_x, term_t t_y,
                                    term_t t_num);
foreign_t pl_num_players_within_2(term_t t_dist, term_t t_num);
foreign_t pl_num_players_within_4(term_t t_dist, term_t t_x, term_t t_y,
                                  term_t t_num); 
foreign_t pl_num_teammates_closer_to_ball(term_t t_num);
foreign_t pl_num_teammates_in_cone(term_t t_wd_ratio, term_t t_ex, term_t t_ey,
                                   term_t t_x, term_t t_y, term_t t_num);
foreign_t pl_num_teammates_within_2(term_t t_dist, term_t t_num);
foreign_t pl_num_teammates_within_4(term_t t_dist, term_t t_x, term_t t_y,
                                    term_t t_num);
foreign_t pl_opponent_in_offside_position(term_t t_unum);
foreign_t pl_pass_ball(term_t t_teammate, term_t t_target_vel);
foreign_t pl_play_mode(term_t t_pm);
foreign_t pl_player_absolute_body_angle(term_t t_side, term_t t_unum, 
					term_t t_ang);
foreign_t pl_player_absolute_neck_angle(term_t t_side, term_t t_unum, 
					term_t t_ang);
foreign_t pl_player_absolute_position(term_t t_side, term_t t_unum,
                                      term_t t_x, term_t t_y);
foreign_t pl_player_absolute_velocity(term_t t_side, term_t t_unum, 
				      term_t t_x, term_t t_y);
foreign_t pl_player_angle_from_body(term_t t_side, term_t t_unum, 
				    term_t t_ang);
foreign_t pl_player_angle_from_neck(term_t t_side, term_t t_unum, 
				    term_t t_ang);
foreign_t pl_player_body_angle_valid2(term_t t_side, term_t t_unum);
foreign_t pl_player_body_angle_valid3(term_t t_side, term_t t_unum, 
				      term_t t_conf);
foreign_t pl_player_distance(term_t t_side, term_t t_unum, term_t t_dist);
foreign_t pl_player_distance_to(term_t t_side, term_t t_unum,
                                term_t t_x, term_t t_y, term_t t_dist);
foreign_t pl_player_in_offside_position(term_t t_side, term_t t_unum);
foreign_t pl_player_interception_cycles(term_t t_side, term_t t_unum,
                                        term_t t_power, term_t t_cycles);
foreign_t pl_player_interception_cycles_maxp(term_t t_side, term_t t_unum,
                                             term_t t_cycles);
foreign_t pl_player_interception_dash_power(term_t t_side, term_t t_unum,
                                            term_t t_power, term_t t_dashp);
foreign_t pl_player_interception_dash_power_maxp(term_t t_side, term_t t_unum,
                                                 term_t t_dashp);
foreign_t pl_player_interception_point(term_t t_side, term_t t_unum,
                                       term_t t_power, term_t t_x, term_t t_y);
foreign_t pl_player_interception_point_maxp(term_t t_side, term_t t_unum,
                                            term_t t_x, term_t t_y);
foreign_t pl_player_interception_result(term_t t_side, term_t t_unum, 
					term_t t_power, term_t t_interc);
foreign_t pl_player_interception_result_maxp(term_t t_side, term_t t_unum, 
					     term_t t_interc);
foreign_t pl_player_interceptionable(term_t t_side, term_t t_unum,
                                     term_t t_power);
foreign_t pl_player_interceptionable_maxp(term_t t_side, term_t t_unum);
foreign_t pl_player_neck_angle_valid2(term_t t_side, term_t t_unum);
foreign_t pl_player_neck_angle_valid3(term_t t_side, term_t t_unum, 
				      term_t t_conf);
foreign_t pl_player_position_valid2(term_t t_side, term_t t_unum,
                                    control_t ctrl);
foreign_t pl_player_position_valid3(term_t t_side, term_t t_unum, 
				    term_t t_conf, control_t ctrl);
foreign_t pl_player_relative_neck_angle(term_t t_side, term_t t_unum, 
					term_t t_ang);
foreign_t pl_player_relative_to_body_body_angle(term_t t_side, term_t t_unum, 
						term_t t_ang);
foreign_t pl_player_relative_to_body_neck_angle(term_t t_side, term_t t_unum, 
						term_t t_ang);
foreign_t pl_player_relative_to_body_heading(term_t t_side, term_t t_unum, 
					     term_t t_ang);
foreign_t pl_player_relative_to_body_position(term_t t_side, term_t t_unum, 
					      term_t t_x, term_t t_y);
foreign_t pl_player_relative_to_body_velocity(term_t t_side, term_t t_unum, 
					      term_t t_x, term_t t_y);
foreign_t pl_player_relative_to_neck_body_angle(term_t t_side, term_t t_unum, 
						term_t t_ang);
foreign_t pl_player_relative_to_neck_neck_angle(term_t t_side, term_t t_unum, 
						term_t t_ang);
/* rsc_player_relative_to_neck_heading gibt es noch nicht
foreign_t pl_player_relative_to_neck_heading(term_t t_side, term_t t_unum, 
term_t t_ang); */

foreign_t pl_player_relative_to_neck_position(term_t t_side, term_t t_unum, 
					      term_t t_x, term_t t_y);
foreign_t pl_player_relative_to_neck_velocity(term_t t_side, term_t t_unum, 
					      term_t t_x, term_t t_y); 	
foreign_t pl_player_speed(term_t t_side, term_t t_unum, term_t t_speed);
foreign_t pl_player_velocity_valid2(term_t t_side, term_t t_unum);
foreign_t pl_player_velocity_valid3(term_t t_side, term_t t_unum, 
				    term_t t_conf);
foreign_t pl_player_x(term_t t_side, term_t t_unum, term_t t_x);
foreign_t pl_player_y(term_t t_side, term_t t_unum, term_t t_y);
foreign_t pl_ray_circle_intersect_7(term_t t_x1, term_t t_y1,
                                    term_t t_x2, term_t t_y2,
                                    term_t t_x3, term_t t_y3, term_t t_rad);
foreign_t pl_say(term_t t_msg);
foreign_t pl_scan_field_with_body();
foreign_t pl_scan_field_with_neck();

foreign_t pl_smart_dribble_to_3(term_t t_x, term_t t_y, term_t t_dribble_res);
foreign_t pl_smart_dribble_to_4(term_t t_x, term_t t_y,
                                term_t t_dash_pow, term_t t_dribble_res);

foreign_t pl_smart_kick_hard_2(term_t t_dir, term_t t_mode);
foreign_t pl_smart_kick_hard_3(term_t t_dir, term_t t_mode, term_t t_ro_vel);
foreign_t pl_smart_kick_hard_4(term_t t_dir, term_t t_mode, term_t t_targ_vel,
                               term_t t_rot);
// absolute dir
foreign_t pl_smart_kick_hard_abs_2(term_t t_dir, term_t t_mode);
foreign_t pl_smart_kick_hard_abs_3(term_t t_dir, term_t t_mode, term_t t_ro_vel);
foreign_t pl_smart_kick_hard_abs_4(term_t t_dir, term_t t_mode, term_t t_targ_vel,
                               term_t t_rot);
foreign_t pl_smart_pass_2(term_t t_x, term_t t_y);
foreign_t pl_smart_pass_3(term_t t_x, term_t t_y, term_t t_targ_vel);
foreign_t pl_smart_pass_4(term_t t_x, term_t t_y, term_t t_targ_vel,
                          term_t t_mode);
foreign_t pl_smart_pass_5(term_t t_x, term_t t_y, term_t t_targ_vel,
                          term_t t_mode, term_t t_rot);
foreign_t pl_stop_ball();
foreign_t pl_team_in_possession_1(term_t t_side);
foreign_t pl_team_with_ball(term_t t_side);
foreign_t pl_teammate_in_offside_position(term_t t_unum);
foreign_t pl_their_goal_marker(term_t t_marker);
foreign_t pl_their_offside_line(term_t t_x);
foreign_t pl_their_score(term_t t_score);
foreign_t pl_their_side(term_t t_side);
foreign_t pl_their_team_name(term_t t_name);
foreign_t pl_their_team_with_ball(void);
foreign_t pl_tired();
foreign_t pl_turn(term_t t_ang);
foreign_t pl_turn_neck(term_t t_ang);
foreign_t pl_test_go_to_ball();
foreign_t pl_test_go_to_point(term_t t_x, term_t t_y,
                              term_t t_buffer, term_t t_power);
foreign_t pl_test_kick();
foreign_t pl_test_kick_2();
foreign_t pl_test_random_movement();
foreign_t pl_vel_at_pt_2_vel_at_foot(term_t t_x, term_t t_y,
                                     term_t t_v_target, term_t t_v_start);

#ifdef __cplusplus
}
#endif


struct player_context_t
{
        Unum n;
        char s; 
};

typedef player_context_t player_context;


#define ERR_FLOAT_EXPECTED "%s: float expected for argument %n\n"
#define ERR_INT_EXPECTED "%s: integer expected for argument %n\n" 
#define ERR_KICKMODE_EXPECTED "%s: kick mode atom expected (hardest, moderate, quicker,\n quickest) for argument %n\n"
#define ERR_SIDE_EXPECTED "%s: atom 'l' or 'r' expected for argument %n\n"
#define ERR_TURN_DIR_EXPECTED "%s: kick turn direction atom expected (avoid, closest,\n counterclockwise, clockwise) for argument %n\n"
#define ERR_TURN_DIR_OR_FLOAT_EXPECTED "%s: float or kick turn direction atom expected (avoid,\n closest, counterclockwise, clockwise) for argument %n\n"
#define ERR_UNUM_EXPECTED "%s: uniform number between 1 and %n expected for argument %n\n"
#endif /* _SWI_ROBOLOG_H_ */
