/* -*- Mode: C++ -*-
   
   this file is part of the robolog libraries
   Copyright (C) May 13 2000 Oliver Obst
   coding functions
   $Id: coding.h,v 2.2 2000/07/13 12:24:31 fruit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _CODING_H_
#define _CODING_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

// functions to en-/decrypt and en-/decode complete messages
void encode(char *out, const char *in, const char *code, int n);
void decode(char *out, const char *in, const char *code);

// functions to en-/decode single chars / digits
int chr2saychr(unsigned char c, char s[4]);
int digit2int(unsigned char c);
char int2digit(int n);
char digit2player(unsigned char c, char mySide, char theirSide, Unum *num);
char player2digit(Unum num, bool myPlayer);

// functions to add a crc checksum to a string and
// strip a crc checksum from a string 
char* add_checksum(char *msg, unsigned int sum);
bool crccheck(char *msg);
char *crcsum(char *In);

#endif // _CODING_H
