/* -*- Mode: C++ -*-
   
   this file is part of the robolog libraries
   Copyright (C) May 13 2000 Oliver Obst
   agents communication stuff
   $Id: communication.h,v 2.6 2000/07/12 13:04:03 fruit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _COMMUNICATION_H_
#define _COMMUNICATION_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

// encode a message and actually say the encoded message
void say_encoded(const char *msg);

// hear a message (get the last heard message from memory)
void hear(char *msg);


// functions to announce objects seen
void announce_positions();
bool announce_ball(char *src, size_t l);
bool announce_player(char *src, size_t l, char side, Unum num);

// functions for KQML communication (hear and say KQML phrases)
void kqml_say(char *perf, char *sender, char *reciever, char *language, char *rw, char *irt, char *content);
void kqml_hear(char *perf, char *sender, char *reciever, char *language, char *rw, char *irt, char *content);

// function to help fill in KQML phrases
void get_def_language(char *language); // get the default language
void get_reply_code(char *code); // get replycode
void get_my_name(char *name); // get playername
void get_his_name(Unum His_Number, char *name); // get teammate name


// a KQML object
class KQML_Obj
{
	private:
		char performative[20];
		char content[512];
		char force[20] ;
		char in_reply_to[20];
		char language[20];
		char ontology[20];
		char reciever[20];
		char reply_with[20];
		char sender[20];
	public:
		KQML_Obj();
		void KQML2elem(char *, char *, char *, char *, char *, char *, char *);
		void elem2KQML(char *, char *, char *, char *, char *, char *, char *);
		void KQML2str(char *);
		void str2KQML(char *);
};



#endif
