/* -*- Mode: C++ -*- 
   this file is part of the robolog libraries
   Copyright (C) Dec 27 1999 Oliver Obst
   dribbling code
   $Id: dribble.h,v 2.1 2000/07/18 10:50:13 fruit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* this code is heavily based on 
-------------------------------------------------------------------------------
 * dribble.h
 * CMUnited99 (soccer client for Robocup99)
 * Peter Stone <pstone@cs.cmu.edu>
 * Computer Science Department
 * Carnegie Mellon University
 * Copyright (C) 1999 Peter Stone
 *
 * CMUnited-99 was created by Peter Stone, Patrick Riley, and Manuela Veloso
 *
 * You may copy and distribute this program freely as long as you retain
 * this notice. If you make any changes or have any comments we would
 * appreciate a message.
 * For more information, please see http://www.cs.cmu.edu/~robosoccer/
-------------------------------------------------------------------------------
 */
#ifndef _DRIBBLE_H_
#define _DRIBBLE_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "types.h"
#include "Memory.h"
#include "kick.h"

void PatsTest_dribble();
void PatsTest_dribble2();



TurnKickCommand dribble_dash(Vector vEndPos, float max_pow,
			     AngleDeg drib_ang, DribbleMode mode);
TurnKickCommand dribble_kick(Vector vEndPos, float max_pow,
			     AngleDeg drib_ang, DribbleMode mode);
AngleDeg NormalizeDribbleAngle(AngleDeg ang);

/* drib_ang should be between 90 and -90
   we always dribble in front of us */
DribbleRes DribbleTo(Vector vEndPos, float max_dash_pow, float buffer,
		     AngleDeg drib_ang, DribbleMode mode,
		     bool IsDodge=false, Vector DodgePoint=0);

DribbleRes SmartDribbleTo(Vector vEndPos, float max_dash_pow, float buffer);
inline DribbleRes SmartDribbleTo(Vector vEndPos, float max_dash_pow)
{ return SmartDribbleTo(vEndPos, max_dash_pow, Mem->CP_at_point_buffer); }
inline DribbleRes SmartDribbleTo(Vector vEndPos)
{ return SmartDribbleTo(vEndPos, Mem->CP_dribble_dash_pow, Mem->CP_at_point_buffer); }

DribbleRes SimpleDribbleTo(Vector vEndPos, float max_dash_pow = 75, 
			  float buffer = 1.0);

AngleDeg GetNormalizeDribAng(AngleDeg ang);
AngleDeg GetNormalizeDribAngWithBuffer(AngleDeg ang);


#endif /* _DIBBLE_H_ */
