/* -*- Mode: C++ -*-

   this file is part of the robolog libraries
   Copyright (C) Jan 2000 Oliver Obst
   server message parsing stuff
   $Id: parse.h,v 2.0 2000/06/13 12:00:43 stolzen Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* this code is heavily based on 
-------------------------------------------------------------------------------
 * parse.h
 * CMUnited99 (soccer client for Robocup99)
 * Peter Stone <pstone@cs.cmu.edu>
 * Computer Science Department
 * Carnegie Mellon University
 * Copyright (C) 1999 Peter Stone
 *
 * CMUnited-99 was created by Peter Stone, Patrick Riley, and Manuela Veloso
 *
 * You may copy and distribute this program freely as long as you retain
 * this notice. If you make any changes or have any comments we would
 * appreciate a message.
 * For more information, please see http://www.cs.cmu.edu/~robosoccer/
-------------------------------------------------------------------------------
 */
#ifndef _PARSE_H_
#define _PARSE_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

void Parse (char *SensoryInfo);
void Parse_Sight(Time time, char *SightInfo);
void Parse_Sense(Time time, char *SenseInfo);
void Parse_Sound(Time time, char *SoundInfo);

void Parse_Player_Sound(char *msg);
void Parse_Referee_Sound(char *RefereeSound);
void Parse_Trainer_Sound(char *msg);
void Parse_My_Coach_Sound(Time time, char *msg);
void Parse_Their_Coach_Sound(Time time, char *msg);

#endif
