/* -*- Mode: C++ -*-
   
   this file is part of the robolog libraries
   Copyright (C) Dec 27 1999 Oliver Obst
   library start up
   $Id: robolog.C,v 2.16 2000/08/22 14:01:10 fruit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "client.h"
#include "coding.h"
#include "communication.h"
#include "types.h"
#include "Memory.h"
#include "behave.h"
#include "kick.h"
#include "dribble.h"
#include "test.h"
#include "robolog.h"

extern Memory *Mem;


extern "C" float rsc_angle_to_from_body(float x, float y)
{ return Mem->AngleToFromBody(Vector(x,y)); }
extern "C" float rsc_angle_to_from_neck(float x, float y)
{ return Mem->AngleToFromNeck(Vector(x,y)); }
extern "C" void rsc_announce_positions()
{ announce_positions(); }
extern "C" bool rsc_at_pos_2(float x, float y)
{ return Mem->AtPos(Vector(x,y)); }
extern "C" bool rsc_at_pos_3(float x, float y, float buf)
{ return Mem->AtPos(Vector(x,y), buf); }
extern "C" bool rsc_at_pos_5(float x0, float y0, float x1, float y1, float buf)
{ return Vector(x1-x0,y1-y0).mod2() < buf*buf; }
extern "C" float rsc_ball_absolute_heading(void)
{ return Mem->BallAbsoluteHeading(); }
extern "C" void rsc_ball_absolute_position(float *x, float *y)
{ Vector p = Mem->BallAbsolutePosition(); *x = p.x; *y = p.y; }
extern "C" void rsc_ball_absolute_velocity(float *x, float *y)
{ Vector p = Mem->BallAbsoluteVelocity(); *x = p.x; *y = p.y; }
extern "C" float rsc_ball_angle_from_body(void)
{ return Mem->BallAngleFromBody(); }
extern "C" float rsc_ball_angle_from_neck(void)
{ return Mem->BallAngleFromNeck(); }
extern "C" float rsc_ball_distance(void)        { return Mem->BallDistance(); }
extern "C" bool rsc_ball_catchable()            { return Mem->BallCatchable();}
extern "C" float rsc_ball_kick_rate()           { return Mem->BallKickRate(); }
extern "C" bool rsc_ball_kickable()             { return Mem->BallKickable(); }
extern "C" bool rsc_ball_kickable_for_player(char s, Unum n, float buffer)
{ return Mem->BallKickableForPlayer(s,n,buffer); }
extern "C" bool rsc_ball_moving()               { return Mem->BallMoving(); }
extern "C" bool rsc_ball_path_intercept_am_i_there(void)
{ return Mem->BallPathInterceptAmIThere(); }
extern "C" bool rsc_ball_path_intercept_am_i_there_1(float buffer)
{ return Mem->BallPathInterceptAmIThere(buffer); }        
extern "C" bool rsc_ball_path_intercept_can_i_get_there(void)
{ return Mem->BallPathInterceptCanIGetThere(); }
extern "C" bool rsc_ball_path_intercept_can_i_get_there_1(float power)
{ return Mem->BallPathInterceptCanIGetThere(power); }
extern "C" int rsc_ball_path_intercept_cycles_for_ball(void)
{ return Mem->BallPathInterceptCyclesForBall(); }
extern "C" float rsc_ball_path_intercept_distance(void)
{ return Mem->BallPathInterceptDistance(); }
extern "C" void rsc_ball_path_intercept_point(float *x, float *y)
{ Vector p = Mem->BallPathInterceptPoint(); *x = p.x; *y = p.y; }
extern "C" bool rsc_ball_path_intercept_valid()
{ return Mem->BallPathInterceptValid(); }
extern "C" float rsc_ball_position_valid(void)
{ return Mem->BallPositionValid(); }
extern "C" Unum rsc_ball_possessor(void)
{ return Mem->BallPossessor(); }
extern "C" float rsc_ball_relative_to_body_heading(void)
{ return Mem->BallRelativeToBodyHeading(); }
extern "C" void rsc_ball_relative_to_body_position(float *x, float *y)
{ Vector p = Mem->BallRelativeToBodyPosition(); *x = p.x; *y = p.y; }
extern "C" void rsc_ball_relative_to_body_velocity(float *x, float *y)
{ Vector p = Mem->BallRelativeToBodyVelocity(); *x = p.x; *y = p.y; }
extern "C" float rsc_ball_relative_to_neck_heading()
{ return Mem->BallRelativeToNeckHeading(); }
extern "C" void rsc_ball_relative_to_neck_position(float *x, float *y)
{ Vector p = Mem->BallRelativeToNeckPosition(); *x = p.x; *y = p.y; }
extern "C" void rsc_ball_relative_to_neck_velocity(float *x, float *y)
{ Vector p = Mem->BallRelativeToNeckVelocity(); *x = p.x; *y = p.y; }
extern "C" float rsc_ball_speed(void)           { return Mem->BallSpeed(); }
extern "C" float rsc_ball_velocity_valid(void)
{ return Mem->BallVelocityValid(); }
extern "C" float rsc_ball_x(void)               { return Mem->BallX(); }
extern "C" float rsc_ball_y(void)               { return Mem->BallY(); }
extern "C" KickMode rsc_best_kick_mode(float ang)
{ return Mem->BestKickMode(ang); }
extern "C" KickMode rsc_best_kick_mode_abs(float ang)
{ return Mem->BestKickModeAbs(ang); }
extern "C" bool rsc_can_face_ball_with_neck()
{ return Mem->CanFaceBallWithNeck(); }
extern "C" bool rsc_can_see_ball_with_neck()
{ return Mem->CanSeeBallWithNeck(); }
extern "C" void rsc_change_view(Vqual qual, Vwidth width)
{ change_view(qual, width); }
extern "C" char* rsc_crcsum(char *msg)
{ return crcsum(msg); }


// JAN
extern "C" Unum rsc_closest_opponent_to_ball(void)
{ return Mem->ClosestOpponentToBall(); }
extern "C" Unum rsc_closest_teammate_to_ball(bool include_me)
{ return Mem->ClosestTeammateToBall(include_me); }

extern "C" void rsc_dash(float power)           { dash(power); }
// return a sector number for an given angle. the circle is divided into
// "sect" sectors, where 0 degrees is in the middle of sector 0. 
extern "C" int rsc_direction_quality(float ang, int sect)
{
        float sect_size = 360 / sect;
        float off = -sect_size / 2;
        
        return (int) (rsc_normalize_angle(ang - off) / sect_size);
}
extern "C" void rsc_disconnect(void)            { disconnect(); }
extern "C" float rsc_distance_to(float x, float y)
{ return Mem->DistanceTo(Vector(x,y)); }
extern "C" DribbleRes rsc_dribble_to_3(float ex, float ey, float drib_ang)
{ return DribbleTo(Vector(ex,ey), Mem->CP_dribble_dash_pow,
                   1, drib_ang, DM_Lazy); }
extern "C" void rsc_encode(char *out, const char *in, const char *code, int n)
{ encode(out, in, code, n); }
extern "C" int rsc_estimated_cycles_to_steal_1(Unum opp)
{ return Mem->EstimatedCyclesToSteal(opp); }
extern "C" Unum rsc_fastest_teammate_to_ball() 
{ return Mem->FastestTeammateToBall(); }
extern "C" Unum rsc_fastest_opponent_to_ball() 
{ return Mem->FastestOpponentToBall(); }
extern "C" ActionQueueRes rsc_face_neck_and_body_to_ball() 
{ return face_neck_and_body_to_ball(); }
extern "C" ActionQueueRes rsc_face_neck_to_ball() 
{ return face_neck_to_ball(); }
extern "C" ActionQueueRes rsc_face_only_body_to_ball()
{ return face_only_body_to_ball(); }
extern "C" void rsc_face_only_neck_to_ball() 
{ face_only_neck_to_ball(); }
extern "C" ActionQueueRes rsc_face_neck_and_body_to_player(char s, Unum n) 
{ return face_neck_and_body_to_player(s,n); }
extern "C" ActionQueueRes rsc_face_neck_to_player(char s, Unum n) 
{ return face_neck_to_player(s,n); }
extern "C" ActionQueueRes rsc_face_only_body_to_player(char s, Unum n)
{ return face_only_body_to_player(s,n); }
extern "C" void rsc_face_only_neck_to_player(char s, Unum n) 
{ face_only_neck_to_player(s,n); }

extern "C" void rsc_get_ball_1(bool force)      { get_ball(force); }
extern "C" void rsc_get_his_name(Unum His_Number, char *name)
{ get_his_name(His_Number, name); }
extern "C" void rsc_get_my_name(char *name) {get_my_name(name);}
extern "C" ActionQueueRes rsc_go_to_point(float x, float y, float buffer,
                                          float dash_power, DodgeType dodge)
{ return go_to_point(Vector(x,y), buffer, dash_power, dodge); }
extern "C" bool rsc_go_to_static_ball(float kick_ang) 
{ return go_to_static_ball(kick_ang); /* JAN: added return  TODO: return something useful here */ }
extern "C" void rsc_goalie_catch(float ang)     { goalie_catch(ang); }
extern "C" Unum rsc_goalie_number(void)
{ return Mem->MyGoalieNumber == 0 ?
          Mem->FP_goalie_number : Mem->MyGoalieNumber; }
extern "C" Unum rsc_goalie_number_1(char s)
{ return s == Mem->MySide ? rsc_goalie_number() : Mem->TheirGoalieNumber; }
extern "C" void rsc_hear(char *msg)		{ hear(msg); }
extern "C" void rsc_hold_ball()                 { hold_ball(); }
extern "C" bool rsc_in_offside_position(void)
{ return Mem->InOffsidePosition(); }
extern "C" bool rsc_is_opponent_behind_2(Unum n, float ang)
{ return Mem->IsOpponentBehind(n, ang); }
extern "C" bool rsc_is_opponent_behind_3(Unum n, float tx, float ty)
{ return Mem->IsOpponentBehind(n, Vector(tx,ty)); }
extern "C" bool rsc_is_opponent_behind_from_body(Unum n)
{ return Mem->IsOpponentBehindFromBody(n); }
extern "C" bool rsc_is_opponent_behind_from_neck(Unum n)
{ return Mem->IsOpponentBehindFromNeck(n); }
extern "C" bool rsc_is_player_behind_3(char s, Unum n, float ang)
{ return Mem->IsPlayerBehind(s, n, ang); }
extern "C" bool rsc_is_player_behind_4(char s, Unum n, float tx, float ty)
{ return Mem->IsPlayerBehind(s, n, Vector(tx,ty)); }
extern "C" bool rsc_is_player_behind_from_body(char s, Unum n)
{ return Mem->IsPlayerBehindFromBody(s, n); }
extern "C" bool rsc_is_player_behind_from_neck(char s, Unum n)
{ return Mem->IsPlayerBehindFromNeck(s, n); }
extern "C" bool rsc_is_point_behind_3(float x, float y, float ang)
{ return Mem->IsPointBehind(Vector(x,y), ang); }
extern "C" bool rsc_is_point_behind_4(float x, float y, float tx, float ty)
{ return Mem->IsPointBehind(Vector(x,y), Vector(tx,ty)); }
extern "C" bool rsc_is_point_behind_body(float x, float y)
{ return Mem->IsPointBehindBody(Vector(x,y)); }
extern "C" bool rsc_is_point_behind_neck(float x, float y)
{ return Mem->IsPointBehindNeck(Vector(x,y)); }
extern "C" bool rsc_is_straight_kick(float dir, float EndDist, float closeMarg)
{ return is_straight_kick(dir, EndDist, closeMarg); }
extern "C" bool rsc_is_teammate_behind_2(Unum n, float ang)
{ return Mem->IsTeammateBehind(n, ang); }
extern "C" bool rsc_is_teammate_behind_3(Unum n, float tx, float ty)
{ return Mem->IsTeammateBehind(n, Vector(tx,ty)); }
extern "C" bool rsc_is_teammate_behind_from_body(Unum n)
{ return Mem->IsTeammateBehindFromBody(n); }
extern "C" bool rsc_is_teammate_behind_from_neck(Unum n)
{ return Mem->IsTeammateBehindFromNeck(n); }
extern "C" void rsc_kick(float power, float dir){ kick(power, dir); }
extern "C" void rsc_kick_ball(float x, float y, KickMode mode, TurnDir rot)
{ kick_ball(Vector(x,y), mode, rot); }
extern "C" bool rsc_kick_in_progress(void)
{ return Mem->KickInProgress(); }
extern "C" void rsc_kqml_say(char *perf, char *sender, char *reciever, char *language, char *rw, char *irt, char *content)
{ kqml_say(perf, sender, reciever, language, rw, irt, content); }
extern "C" void rsc_kqml_hear(char *perf, char *sender, char *reciever, char *language, char *rw, char *irt, char *content)
{ kqml_hear(perf, sender, reciever, language, rw, irt, content); }
extern "C" char rsc_last_team_in_possession(void) 
{ return Mem->LastTeamInPossession(); }
extern "C" Fside rsc_location_side(float x, float y)
{ return Mem->LocationSide(Vector(x,y)); }
// JAN
extern "C" void rsc_log_action2(int level, char *msg)
{ Mem->LogAction2(level, msg); }
extern "C" float rsc_marker_distance(MarkerType m)
{ return Mem->MarkerDistance(m); }
extern "C" float rsc_marker_distance_sqr(MarkerType m)
{ return Mem->MarkerDistance2(m); }
extern "C" float rsc_marker_angle_from_body(MarkerType m)
{ return Mem->MarkerAngleFromBody(m); }
extern "C" float rsc_marker_angle_from_neck(MarkerType m)
{ return Mem->MarkerAngleFromNeck(m); }
extern "C" void rsc_marker_position(MarkerType m, float *x, float *y)
{ Vector p = Mem->MarkerPosition(m); *x = p.x; *y = p.y; }
extern "C" float rsc_marker_x(MarkerType m)     { return Mem->MarkerX(m); }
extern "C" float rsc_marker_y(MarkerType m)     { return Mem->MarkerY(m); }
extern "C" float rsc_marker_position_valid(MarkerType m)
{ return Mem->MarkerPositionValid(m); }
extern "C" void rsc_move(float x, float y)      { move(x,y); }
extern "C" float rsc_my_body_ang(void)          { return Mem->MyBodyAng(); }
extern "C" float rsc_my_conf(void)              { return Mem->MyConf(); }
extern "C" float rsc_my_dir(void)               { return Mem->MyDir(); }
extern "C" MarkerType rsc_my_goal_marker(void)  { return Mem->RM_My_Goal; }
extern "C" float rsc_my_effort(void)            { return Mem->MyEffort(); }
extern "C" Fside rsc_my_location_side(void)
{ return Mem->MyLocationSide(); }
extern "C" float rsc_my_neck_global_ang(void)
{ return Mem->MyNeckGlobalAng(); }
extern "C" float rsc_my_neck_rel_ang(void)
{ return Mem->MyNeckRelAng(); }
extern "C" Unum rsc_my_number(void)             { return Mem->MyNumber; }
extern "C" float rsc_my_offside_line(void)      { return Mem->my_offside_line;}
extern "C" void rsc_my_pos(float *x, float *y)
{ Vector p = Mem->MyPos(); *x = p.x; *y = p.y; }
extern "C" float rsc_my_recovery(void)          { return Mem->MyRecovery(); }
extern "C" int rsc_my_score(void)               { return Mem->MyScore; }
extern "C" char rsc_my_side(void)               { return Mem->MySide; }
extern "C" float rsc_my_speed(void)             { return Mem->MySpeed(); }
extern "C" float rsc_my_stamina(void)           { return Mem->MyStamina(); }
extern "C" char *rsc_my_team_name(void)         { return Mem->MyTeamName; }
extern "C" int rsc_my_team_name_len(void)       { return Mem->MyTeamNameLen; }
extern "C" void rsc_my_vel(float *x, float *y)
{ Vector p = Mem->MyVel(); *x = p.x; *y = p.y; }
extern "C" float rsc_my_vel_conf(void)          { return Mem->MyVelConf(); }
extern "C" float rsc_my_view_angle(void)        { return Mem->MyViewAngle(); }
extern "C" float rsc_my_x(void)                 { return Mem->MyX(); }
extern "C" float rsc_my_y(void)                 { return Mem->MyY(); }
// normalize angle: 0 <= angle <= 360
extern "C" float rsc_normalize_angle(float ang)
{ return GetNormalize1AngleDeg(ang); }
// normalize angle: -180 <= angle <= 180
extern "C" float rsc_normalize2_angle(float ang)
{ return GetNormalizeAngleDeg(ang); }
// JAN: return the current time
extern "C" int rsc_now()                      { return Mem->CurrentTime.t; }
//JAN
extern "C" int rsc_num_opponents_closer_to_ball(void) 
{ return Mem->NumOpponentsCloserToBall(); }
extern "C" int rsc_num_opponents_in_cone(float wd_ratio, float ex, float ey,
                                         float x, float y)
{ return Mem->NumOpponentsInCone(wd_ratio,Vector(ex,ey),Vector(x,y)); }
extern "C" int rsc_num_opponents_within_1(float dist) 
{ return Mem->NumOpponentsWithin(dist); }
extern "C" int rsc_num_opponents_within_3(float dist, float of_x, float of_y)
{ return Mem->NumOpponentsWithin(dist,Vector(of_x,of_y)); }        
extern "C" int rsc_num_players_within_1(float dist)
{ return Mem->NumPlayersWithin(dist); }
extern "C" int rsc_num_players_within_3(float dist, float of_x, float of_y)
{ return Mem->NumPlayersWithin(dist, Vector(of_x,of_y)); }
//JAN
extern "C" int rsc_num_teammates_closer_to_ball(void) 
{ return Mem->NumTeammatesCloserToBall(); }

extern "C" int rsc_num_teammates_in_cone(float wd_ratio, float ex, float ey,
                                         float x, float y)
{ return Mem->NumTeammatesInCone(wd_ratio,Vector(ex,ey),Vector(x,y)); }
extern "C" int rsc_num_teammates_within_1(float dist)
{ return Mem->NumTeammatesWithin(dist); }
extern "C" int rsc_num_teammates_within_3(float dist, float of_x, float of_y)
{ return Mem->NumTeammatesWithin(dist, Vector(of_x,of_y)); }
extern "C" bool rsc_opponent_in_offside_position(Unum num)
{ return Mem->OpponentInOffsidePosition(num); }
extern "C" void rsc_pass_ball(Unum teammate, float target_vel)
{ pass_ball(teammate, target_vel); }
extern "C" Pmode rsc_play_mode(void)            { return Mem->PlayMode; }
extern "C" float rsc_player_absolute_body_angle(char s, Unum n)
{ return Mem->PlayerAbsoluteBodyAngle(s, n); }
extern "C" float rsc_player_absolute_neck_angle(char s, Unum n)
{ return Mem->PlayerAbsoluteNeckAngle(s, n); }
extern "C" void rsc_player_absolute_position(char s, Unum n,
                                             float *x, float *y)
{ Vector p = Mem->PlayerAbsolutePosition(s, n);
  *x = p.x; *y = p.y; }
extern "C" void rsc_player_absolute_velocity(char s, Unum n,
                                             float *x, float *y)
{ Vector p = Mem->PlayerAbsoluteVelocity(s, n);
  *x = p.x; *y = p.y; }
extern "C" float rsc_player_angle_from_body(char s, Unum n)
{ return Mem->PlayerAngleFromBody(s, n); }
extern "C" float rsc_player_angle_from_neck(char s, Unum n)
{ return Mem->PlayerAngleFromNeck(s, n); }
extern "C" float rsc_player_body_angle_valid(char s, Unum n)
{ return Mem->PlayerBodyAngleValid(s, n); }
extern "C" float rsc_player_distance(char s, Unum n)
{ return Mem->PlayerDistance(s, n); }
extern "C" float rsc_player_distance_to(char s, Unum n, float x, float y)
{ return Mem->PlayerDistanceTo(s, n, Vector(x,y)); }
extern "C" bool rsc_player_in_offside_position(char s, Unum num)
{ return Mem->PlayerInOffsidePosition(s, num); }
extern "C" int rsc_player_interception_cycles(char s, Unum n, float dash_power)
{ return Mem->PlayerInterceptionNumberCycles(s, n, dash_power); }
extern "C" int rsc_player_interception_cycles_maxp(char s, Unum n)
{ return Mem->PlayerInterceptionNumberCycles(s, n); }        
extern "C" float rsc_player_interception_dash_power(char s, Unum n,
                                                    float dash_power)
{ return Mem->PlayerInterceptionDashPower(s, n, dash_power); }
extern "C" float rsc_player_interception_dash_power_maxp(char s, Unum n)
{ return Mem->PlayerInterceptionDashPower(s, n); }
extern "C" void rsc_player_interception_point(char s, Unum n, float dash_power,
                                              float *x, float *y)
{ Vector p = Mem->PlayerInterceptionPoint(s, n, dash_power);
 *x = p.x; *y = p.y; }
extern void rsc_player_interception_point_maxp(char s, Unum n,
                                               float *x, float *y)
{ Vector p = Mem->PlayerInterceptionPoint(s, n);
 *x = p.x; *y = p.y; }
extern "C" InterceptRes rsc_player_interception_result(char s, Unum n,
                                                       float dash_power)
{ return Mem->PlayerInterceptionResult(s,n,dash_power); }
extern "C" InterceptRes rsc_player_interception_result_maxp(char s, Unum n)
{ return Mem->PlayerInterceptionResult(s,n); }
extern "C" bool rsc_player_interceptionable(char s, Unum n, float dash_power)
{ return Mem->PlayerInterceptionAble(s,n,dash_power); }
extern "C" bool rsc_player_interceptionable_maxp(char s, Unum n)
{ return Mem->PlayerInterceptionAble(s,n); }        
extern "C" float rsc_player_neck_angle_valid(char s, Unum n)
{ return Mem->PlayerNeckAngleValid(s, n); }
extern "C" float rsc_player_position_valid(char s, Unum n)
{ return Mem->PlayerPositionValid(s, n); }
extern "C" float rsc_player_relative_neck_angle(char s, Unum n)
{ return Mem->PlayerRelativeNeckAngle(s, n); }
extern "C" float rsc_player_relative_to_body_body_angle(char s, Unum n)
{ return Mem->PlayerRelativeToBodyBodyAngle(s, n); }
extern "C" float rsc_player_relative_to_body_neck_angle(char s, Unum n)
{ return Mem->PlayerRelativeToBodyNeckAngle(s, n); }
extern "C" float rsc_player_relative_to_body_heading(char s, Unum n)
{ return Mem->PlayerRelativeToBodyHeading(s, n); }
extern "C" void rsc_player_relative_to_body_position(char s, Unum n,
                                                     float *x, float *y)
{ Vector p = Mem->PlayerRelativeToBodyPosition(s, n);
  *x = p.x; *y = p.y; }
extern "C" void rsc_player_relative_to_body_velocity(char s, Unum n,
                                                     float *x, float *y)
{ Vector p = Mem->PlayerRelativeToBodyVelocity(s, n);
  *x = p.x; *y = p.y; }
extern "C" float rsc_player_relative_to_neck_body_angle(char s, Unum n)
{ return Mem->PlayerRelativeToNeckBodyAngle(s, n); }
extern "C" float rsc_player_relative_to_neck_neck_angle(char s, Unum n)
{ return Mem->PlayerRelativeToNeckNeckAngle(s, n); }
extern "C" void rsc_player_relative_to_neck_position(char s, Unum n,
                                                     float *x, float *y)
{ Vector p = Mem->PlayerRelativeToNeckPosition(s, n);
  *x = p.x; *y = p.y; }
extern "C" void rsc_player_relative_to_neck_velocity(char s, Unum n,
                                                     float *x, float *y)
{ Vector p = Mem->PlayerRelativeToNeckVelocity(s, n);
  *x = p.x; *y = p.y; }
extern "C" float rsc_player_speed(char s, Unum n)
{ return Mem->PlayerSpeed(s, n); }
extern "C" float rsc_player_velocity_valid(char s, Unum n)
{ return Mem->PlayerVelocityValid(s, n); }
extern "C" float rsc_player_x(char s, Unum n)
{ return Mem->PlayerX(s, n); }
extern "C" float rsc_player_y(char s, Unum n)
{ return Mem->PlayerY(s, n); }
extern "C" int rsc_ray_circle_intersect_7(float x1, float y1,
                                          float x2, float y2,
                                          float x3, float y3, float radius)
{
        Vector s1,s2;
        Ray r(Vector(x1,y1), Vector(x2-x1,y2-y1));
        return r.CircleIntersect(radius,Vector(x3,y3),&s1,&s2);
}
extern "C" void rsc_say(const char *msg)        { say(msg); }
extern "C" ActionQueueRes rsc_scan_field_with_body()
{ return scan_field_with_body(); }
//{ return rsc_scan_field_with_body(); }
extern "C" void rsc_scan_field_with_neck() 
{ scan_field_with_neck(); }
extern "C" DribbleRes
rsc_smart_dribble_to_2(float x, float y) 
{ return SmartDribbleTo(Vector(x,y)); }
extern "C" DribbleRes
rsc_smart_dribble_to_3(float x, float y, float max_dash_pow)
{ return SmartDribbleTo(Vector(x,y), max_dash_pow); }
extern "C" bool rsc_smart_kick_hard_2(float rel_dir, KickMode mode)
{ return smart_kick_hard(rel_dir, mode) == 1 ? true : false; }
extern "C" bool rsc_smart_kick_hard_3(float rel_dir, KickMode mode,
                                      float targ_vel)
{ return smart_kick_hard(rel_dir, mode, targ_vel) == 1 ? true : false; }
extern "C" bool rsc_smart_kick_hard_rot_3(float rel_dir, KickMode mode,
                                          TurnDir rot)
{ return smart_kick_hard(rel_dir, mode, rot) == 1 ? true : false; }
extern "C" bool rsc_smart_kick_hard_rot_4(float rel_dir, KickMode mode,
                                          float targ_vel, TurnDir rot)
{ return smart_kick_hard(rel_dir, mode, targ_vel, rot) == 1 ? true : false; }
extern "C" bool rsc_smart_kick_hard_abs_2(float abs_dir, KickMode mode)
{ return smart_kick_hard_abs(abs_dir, mode) == 1 ? true : false; }
extern "C" bool rsc_smart_kick_hard_abs_3(float abs_dir, KickMode mode,
                                          float targ_vel)
{ return smart_kick_hard_abs(abs_dir, mode, targ_vel) == 1 ? true : false; }
extern "C" bool rsc_smart_kick_hard_rot_abs_3(float abs_dir, KickMode mode,
                                              TurnDir rot)
{ return smart_kick_hard_abs(abs_dir, mode, rot) == 1 ? true : false; }
extern "C" bool rsc_smart_kick_hard_rot_abs_4(float abs_dir, KickMode mode,
                                              float targ_vel, TurnDir rot)
{ return smart_kick_hard_abs(abs_dir, mode, targ_vel, rot) == 1 ?
          true : false; }
extern "C" bool rsc_smart_pass_2(float x, float y)
{ return smart_pass(Vector(x,y)) == 1 ? true : false; }
extern bool rsc_smart_pass_3(float x, float y, float targ_vel)
{ return smart_pass(Vector(x,y), targ_vel) == 1 ? true : false; }        
extern bool rsc_smart_pass_4(float x, float y, float targ_vel, KickMode mode)
{ return smart_pass(Vector(x,y), targ_vel, mode) == 1 ? true : false; }
extern bool rsc_smart_pass_5(float x, float y, float targ_vel,
                             KickMode mode, TurnDir rot)
{ return smart_pass(Vector(x,y), targ_vel, mode, rot) == 1 ? true : false; }
extern "C" int rsc_SP_team_size()               { return Mem->SP_team_size; }
extern "C" void rsc_stop_ball()                 { stop_ball(); }
extern "C" char rsc_team_in_possession(float)
{ return Mem->TeamInPossession(); }
extern "C" char rsc_team_with_ball(float buffer)
{ return Mem->TeamWithBall(buffer); }
extern "C" bool rsc_teammate_in_offside_position(Unum num)
{ return Mem->TeammateInOffsidePosition(num); }
extern "C" void rsc_test_go_to_ball(void)       { test_go_to_ball(); }
extern "C" void rsc_test_go_to_point(float x, float y,
                                     float buffer, float power)
{ test_go_to_point(Vector(x, y), buffer, power); }
extern "C" void rsc_test_kick()                 { PatsTest_kick(); }
extern "C" void rsc_test_kick_2()               { PatsTest_kick2(); }
extern "C" void rsc_test_random_movement(void)  { test_random_movement(); }
extern "C" MarkerType rsc_their_goal_marker(void)
{ return Mem->RM_Their_Goal; }
extern "C" float rsc_their_offside_line(void)
{ return Mem->their_offside_line; }
extern "C" int rsc_their_score(void)            { return Mem->TheirScore; }
extern "C" char rsc_their_side(void)            { return Mem->TheirSide; }
extern "C" char *rsc_their_team_name(void)      { return Mem->TheirTeamName; }
extern "C" bool rsc_tired(void)                 { return Mem->Tired(); }
extern "C" void rsc_turn(float ang)             { turn(ang); }
extern "C" void rsc_turn_neck(float ang)        { turn_neck(ang); }
extern "C" float rsc_vel_at_pt_2_vel_at_foot(float x, float y, float v_target)
{ return Mem->VelAtPt2VelAtFoot(Vector(x,y), v_target); }
