/* -*- mode: c -*-
   
   this file is part of the robolog libraries
   Copyright (C) Dec 27 1999 Oliver Obst
   header file for the robolog c library
   $Id: robolog.h,v 2.14 2000/08/22 14:00:42 fruit Exp $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _ROBOLOG_H_
#define _ROBOLOG_H_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <robolog/types.h>

#ifdef __cplusplus
extern "C" {
#endif
        
#if 0 /* only to switch of stupid xemacs indenting */
}
#endif

extern void rsc_main(int argc, char **argv);

extern void rsc_announce_positions();
extern float rsc_angle_to_from_body(float x, float y);
extern float rsc_angle_to_from_neck(float x, float y);
extern bool rsc_at_pos_2(float x, float y);
extern bool rsc_at_pos_3(float x, float y, float buf);
extern bool rsc_at_pos_5(float x0, float y0, float x1, float y1, float buf);
extern float rsc_ball_absolute_heading(void);
extern void rsc_ball_absolute_position(float *x, float *y);
extern void rsc_ball_absolute_velocity(float *x, float *y);
extern float rsc_ball_angle_from_body(void);
extern float rsc_ball_angle_from_neck(void);
extern bool rsc_ball_catchable();
extern float rsc_ball_distance(void);
extern float rsc_ball_kick_rate();
extern bool rsc_ball_kickable();
extern bool rsc_ball_kickable_for_player(char s, Unum n, float buffer);
extern bool rsc_ball_moving();
extern bool rsc_ball_path_intercept_am_i_there(void);
extern bool rsc_ball_path_intercept_am_i_there_1(float buffer);
extern bool rsc_ball_path_intercept_can_i_get_there(void);
extern bool rsc_ball_path_intercept_can_i_get_there_1(float buffer);
extern int rsc_ball_path_intercept_cycles_for_ball(void);
extern float rsc_ball_path_intercept_distance(void);
extern void rsc_ball_path_intercept_point(float *x, float *y);
extern bool rsc_ball_path_intercept_valid(void);
extern float rsc_ball_position_valid(void);
extern Unum rsc_ball_possessor(void);
extern float rsc_ball_relative_to_body_heading();
extern void rsc_ball_relative_to_body_position(float *x, float *y);
extern void rsc_ball_relative_to_body_velocity(float *x, float *y);
extern float rsc_ball_relative_to_neck_heading();
extern void rsc_ball_relative_to_neck_position(float *x, float *y);
extern void rsc_ball_relative_to_neck_velocity(float *x, float *y);
extern float rsc_ball_speed(void);
extern float rsc_ball_velocity_valid(void);
extern float rsc_ball_x(void);
extern float rsc_ball_y(void);
extern KickMode rsc_best_kick_mode(float ang);
extern KickMode rsc_best_kick_mode_abs(float ang);
extern bool rsc_can_face_ball_with_neck();
extern bool rsc_can_see_ball_with_neck();
extern void rsc_change_view(Vqual qual, Vwidth width);
extern char* rsc_crcsum(char *msg);
extern Unum rsc_closest_opponent_to_ball(void);
extern Unum rsc_closest_teammate_to_ball(bool include_me = false);
extern void rsc_dash(float power);
extern int rsc_direction_quality(float ang, int sect);
extern void rsc_disconnect(void);
extern float rsc_distance_to(float x, float y);
extern DribbleRes rsc_dribble_to_3(float ex, float ey, float drib_ang);
extern void rsc_encode(char *out, const char *in, const char *code, int n);
extern int rsc_estimated_cycles_to_steal_1(Unum opp);
extern Unum rsc_fastest_teammate_to_ball();
extern Unum rsc_fastest_opponent_to_ball();
extern ActionQueueRes rsc_face_neck_and_body_to_ball();
extern ActionQueueRes rsc_face_neck_to_ball();
extern ActionQueueRes rsc_face_only_body_to_ball();
extern void rsc_face_only_neck_to_ball();
extern ActionQueueRes rsc_face_neck_and_body_to_player(char s, Unum n);
extern ActionQueueRes rsc_face_neck_to_player(char s, Unum n);
extern ActionQueueRes rsc_face_only_body_to_player(char s, Unum n);
extern void rsc_face_only_neck_to_player(char s, Unum n);
extern void rsc_get_ball_1(bool force);
extern void rsc_get_his_name(Unum His_Number, char *name);
extern void rsc_get_my_name(char *name);
extern ActionQueueRes rsc_go_to_point(float x, float y, float buffer,
                                      float dash_power, DodgeType dodge);
extern bool rsc_go_to_static_ball(float kick_ang);
extern void rsc_goalie_catch(float ang);
extern Unum rsc_goalie_number(void);
extern Unum rsc_goalie_number_1(char s);
extern void rsc_hold_ball(void);
extern void rsc_hear(char *msg);
extern bool rsc_in_offside_position(void);
extern bool rsc_is_opponent_behind_2(Unum n, float ang);
extern bool rsc_is_opponent_behind_3(Unum n, float tx, float ty);
extern bool rsc_is_opponent_behind_from_body(Unum n);
extern bool rsc_is_opponent_behind_from_neck(Unum n);
extern bool rsc_is_player_behind_3(char s, Unum n, float ang);
extern bool rsc_is_player_behind_4(char s, Unum n, float tx, float ty);
extern bool rsc_is_player_behind_from_body(char s, Unum n);
extern bool rsc_is_player_behind_from_neck(char s, Unum n);
extern bool rsc_is_point_behind_3(float x, float y, float ang);
extern bool rsc_is_point_behind_4(float x, float y, float tx, float ty);
extern bool rsc_is_point_behind_body(float x, float y);
extern bool rsc_is_point_behind_neck(float x, float y);
extern bool rsc_is_straight_kick(float dir, float EndDist, float closeMarg);
extern bool rsc_is_teammate_behind_2(Unum n, float ang);
extern bool rsc_is_teammate_behind_3(Unum n, float tx, float ty);
extern bool rsc_is_teammate_behind_from_body(Unum n);
extern bool rsc_is_teammate_behind_from_neck(Unum n);
extern void rsc_kick(float power, float dir);
extern void rsc_kick_ball(float x, float y, KickMode mode, TurnDir rot);
extern bool rsc_kick_in_progress(void);
extern void rsc_kqml_say(char *perf, char *sender, char *reciever,
                         char *language, char *rw, char *irt, char *content);
extern void rsc_kqml_hear(char *perf, char *sender, char *reciever,
                          char *language, char *rw, char *irt, char *content);
extern char rsc_last_team_in_possession(void);
extern Fside rsc_location_side(float x, float y);
// JAN
extern void rsc_log_action2(int level, char *msg);
extern float rsc_marker_distance(MarkerType m);
extern float rsc_marker_distance_sqr(MarkerType m);
extern float rsc_marker_angle_from_body(MarkerType m);
extern float rsc_marker_angle_from_neck(MarkerType m);
extern void rsc_marker_position(MarkerType m, float *x, float *y);
extern float rsc_marker_x(MarkerType m);
extern float rsc_marker_y(MarkerType m);
extern float rsc_marker_position_valid(MarkerType m);
extern void rsc_move(float x, float y);
extern float rsc_my_body_ang(void);
extern float rsc_my_conf(void);
extern float rsc_my_dir(void);
extern float rsc_my_effort(void);
extern MarkerType rsc_my_goal_marker(void);
extern Fside rsc_my_location_side(void);
extern float rsc_my_neck_global_ang(void);
extern float rsc_my_neck_rel_ang(void);
extern Unum rsc_my_number(void);
extern float rsc_my_offside_line(void);
extern void rsc_my_pos(float *x, float *y);
extern float rsc_my_recovery(void);
extern int rsc_my_score(void);
extern char rsc_my_side(void);
extern float rsc_my_speed(void);
extern float rsc_my_stamina(void);
extern char *rsc_my_team_name(void);
extern int rsc_my_team_name_len(void);
extern void rsc_my_vel(float *x, float *y);
extern float rsc_my_vel_conf(void);
extern float rsc_my_view_angle(void);
extern float rsc_my_x(void);
extern float rsc_my_y(void);
extern float rsc_normalize_angle(float ang);
extern float rsc_normalize2_angle(float ang);
// JAN: return the current time
extern int rsc_now(void);
//JAN
extern int rsc_num_opponents_closer_to_ball(void);

extern int rsc_num_opponents_in_cone(float wd_ratio, float ex, float ey,
                                     float x, float y);
extern int rsc_num_opponents_within_1(float dist);
extern int rsc_num_opponents_within_3(float dist, float of_x, float of_y);
extern int rsc_num_players_within_1(float dist);
extern int rsc_num_players_within_3(float dist, float of_x, float of_y);
//JAN
extern int rsc_num_teammates_closer_to_ball(void);
extern int rsc_num_teammates_in_cone(float wd_ratio, float ex, float ey,
                                     float x, float y);
extern int rsc_num_teammates_within_1(float dist);
extern int rsc_num_teammates_within_3(float dist, float of_x, float of_y);

extern bool rsc_opponent_in_offside_position(Unum num);
extern void rsc_pass_ball(Unum teammate, float target_vel);
extern Pmode rsc_play_mode(void);
extern float rsc_player_absolute_body_angle(char s, Unum n);
extern float rsc_player_absolute_neck_angle(char s, Unum n);
extern void rsc_player_absolute_position(char s, Unum n, float *x, float *y);
extern void rsc_player_absolute_velocity(char s, Unum n, float *x, float *y);
extern float rsc_player_angle_from_body(char s, Unum n);
extern float rsc_player_angle_from_neck(char s, Unum n);
extern float rsc_player_body_angle_valid(char s, Unum n);
extern float rsc_player_distance(char s, Unum n);
extern float rsc_player_distance_to(char s, Unum n, float x, float y);
extern bool rsc_player_in_offside_position(char s, Unum num);
extern int rsc_player_interception_cycles(char s, Unum n, float dash_power);
extern int rsc_player_interception_cycles_maxp(char s, Unum n);
extern float rsc_player_interception_dash_power(char s, Unum n,
                                                float dash_power);
extern float rsc_player_interception_dash_power_maxp(char s, Unum n);
extern void rsc_player_interception_point(char s, Unum n, float dash_power,
                                          float *x, float *y);
extern void rsc_player_interception_point_maxp(char s, Unum n,
                                               float *x, float *y);
extern InterceptRes rsc_player_interception_result(char s, Unum n,
                                                   float dash_power);
extern InterceptRes rsc_player_interception_result_maxp(char s, Unum n);
extern bool rsc_player_interceptionable(char s, Unum n, float dash_power);
extern bool rsc_player_interceptionable_maxp(char s, Unum n);
extern float rsc_player_neck_angle_valid(char s, Unum n);
extern float rsc_player_position_valid(char s, Unum n);
extern float rsc_player_relative_neck_angle(char s, Unum n);
extern float rsc_player_relative_to_body_body_angle(char s, Unum n);
extern float rsc_player_relative_to_body_neck_angle(char s, Unum n);
extern float rsc_player_relative_to_body_heading(char s, Unum n);
extern void rsc_player_relative_to_body_position(char s, Unum n,
                                                 float *x, float *y);
extern void rsc_player_relative_to_body_velocity(char s, Unum n,
                                                 float *x, float *y);
extern float rsc_player_relative_to_neck_body_angle(char s, Unum n);
extern float rsc_player_relative_to_neck_neck_angle(char s, Unum n);
extern void rsc_player_relative_to_neck_position(char s, Unum n,
                                                 float *x, float *y);
extern void rsc_player_relative_to_neck_velocity(char s, Unum n,
                                                 float *x, float *y);
extern float rsc_player_speed(char s, Unum n);
extern float rsc_player_velocity_valid(char s, Unum n);
extern float rsc_player_x(char s, Unum n);
extern float rsc_player_y(char s, Unum n);
extern int rsc_ray_circle_intersect_7(float x1, float y1,
                                      float x2, float y2,
                                      float x3, float y3, float radius);
extern void rsc_say(const char *msg);
extern ActionQueueRes rsc_scan_field_with_body();
extern void rsc_scan_field_with_neck();
extern DribbleRes rsc_smart_dribble_to_2(float x, float y);
extern DribbleRes rsc_smart_dribble_to_3(float x, float y, float max_dash_pow);
extern bool rsc_smart_kick_hard_2(float rel_dir, KickMode mode);
extern bool rsc_smart_kick_hard_3(float rel_dir, KickMode mode,
                                  float targ_vel);
extern bool rsc_smart_kick_hard_rot_3(float rel_dir, KickMode mode,
                                      TurnDir rot);
extern bool rsc_smart_kick_hard_rot_4(float rel_dir, KickMode mode,
                                      float targ_vel, TurnDir rot);
extern bool rsc_smart_kick_hard_abs_2(float abs_dir, KickMode mode);
extern bool rsc_smart_kick_hard_abs_3(float abs_dir, KickMode mode,
                                      float targ_vel);
extern bool rsc_smart_kick_hard_rot_abs_3(float abs_dir, KickMode mode,
                                          TurnDir rot);
extern bool rsc_smart_kick_hard_rot_abs_4(float rel_dir, KickMode mode,
                                          float targ_vel, TurnDir rot);
extern bool rsc_smart_pass_2(float x, float y);
extern bool rsc_smart_pass_3(float x, float y, float targ_vel);
extern bool rsc_smart_pass_4(float x, float y, float targ_vel, KickMode mode);
extern bool rsc_smart_pass_5(float x, float y, float targ_vel,
                             KickMode mode, TurnDir rot);
extern int rsc_SP_team_size(void);
extern void rsc_stop_ball(void);
extern char rsc_team_in_possession(float buffer);
extern char rsc_team_with_ball(float buffer);
extern bool rsc_teammate_in_offside_position(Unum num);
extern void rsc_test_go_to_ball(void);
extern void rsc_test_go_to_point(float x, float y, float buffer, float power);
extern void rsc_test_kick();
extern void rsc_test_kick_2();
extern void rsc_test_random_movement(void);
extern MarkerType rsc_their_goal_marker(void);
extern float rsc_their_offside_line(void);
extern int rsc_their_score(void);
extern char rsc_their_side(void);
extern char *rsc_their_team_name(void);
extern bool rsc_tired(void);
extern void rsc_turn(float ang);
extern void rsc_turn_neck(float ang);
extern float rsc_vel_at_pt_2_vel_at_foot(float x, float y, float v_target);

#ifdef __cplusplus
}
#endif

#endif /* _ROBOLOG_H_ */
